OPTIONS SHORT CIRCUIT
--****************************************************************************--
--                           LIENS DOCUMENTATION                              --
--****************************************************************************--
-- valeurs par dfaut variable DEFINE : 
--   https://4js.com/online_documentation/fjs-fgl-manual-html/#fgl-topics/c_fgl_variables_008.html
-- passage de parametres au fonction par rfrence (optimisation) :
--   https://4js.com/online_documentation/fjs-fgl-manual-html/#fgl-topics/c_fgl_optimization_016.html
--****************************************************************************--
--                    REMARQUES IMPORTANTES A SAVOIR                          --
--****************************************************************************--
-- Le fait de faire des INPUT dans le DISPLAY ARRAY a pour effet de "dsynchroniser"
-- le DIALOG principal donc les autres champs du DIALOG ne sont plus accessibles
-- il faut tre attentif a cela au niveau de la programmation ...
-- p.ex. : le UNBUFFERED du DIALOG n'est pas compatible dans l'INPUT ...
-- si dans les INPUTS on appel des mthodes de ui.Dialog celles-ci ont 
-- un comportement pas logique et d'autres fonctionnent
-- p.ex.: le DIALOG.nextfield est utilisable
--        le DIALOG.getCurrentItem donne des rsultats bizarres ...
--**********************************************************************************
--****************************************************************************--
--                                IMPORTATIONS                                --
--****************************************************************************--
-- Modules standard Genero
IMPORT ui
IMPORT FGL fgldialog
-- Modules librairies 4gl Provencale
IMPORT FGL libdbutils
IMPORT FGL libcolors
-- Modules 4gl majtlamrg
IMPORT FGL glbmrgprx
IMPORT FGL cstmrgprx
IMPORT FGL classTlamrg
IMPORT FGL classTlamrgcli
IMPORT FGL classTlamrggrp
--****************************************************************************--
--                     TYPES POUR INTERFACE POUR SCREEN RECORD                --
--****************************************************************************--
PRIVATE TYPE tsr_tlamrgmrg RECORD                    -- SCREEN RECORD sr_tlamrgmrg (valeurs)
   cligrp                   CHAR(1)                  --   LABEL     a00 = FORMONLY.cligrp00  TYPE CHAR           ,TITLE='*', JUSTIFY=CENTER;
  ,numart                   STRING                   --   LABEL     a01 = FORMONLY.numart00  TYPE CHAR           ,TITLE='Article';
  ,libart                   STRING                   --   LABEL     a02 = FORMONLY.libart00  TYPE DATE           ,TITLE='Libell';
  ,orgart                   STRING                   --   LABEL     a03 = FORMONLY.orgart00  TYPE CHAR           ,TITLE='Origine';
  ,embart                   STRING                   --   LABEL     a06 = FORMONLY.embart00  TYPE CHAR           ,TITLE='Embal.';
  ,codmag                   STRING                   --   LABEL     a15 = FORMONLY.codmag00  TYPE CHAR           ,TITLE='Mag.';
  ,datmrg                   DATE                     --   LABEL     a07 = FORMONLY.datmrg00  TYPE DATE           ,TITLE='Date';
  ,mrgstd                   DECIMAL(6,2)             --   EDIT      a08 = FORMONLY.mrgstd00  TYPE DECIMAL(6,2)   ,TITLE='%Std.';
  ,mrgqte                   DECIMAL(6,2)             --   EDIT      a09 = FORMONLY.mrgqte00  TYPE DECIMAL(6,2)   ,TITLE='%Qte.';
  ,qtemin                   DECIMAL(9,3)             --   EDIT      a10 = FORMONLY.qtemin00  TYPE DECIMAL(9,3)   ,TITLE='Qte Min.';
  ,untven                   STRING                   --   LABEL     a11 = FORMONLY.untven00  TYPE CHAR           ,TITLE='Vente';
  ,untuld                   STRING                   --   LABEL     a12 = FORMONLY.untuld00  TYPE CHAR           ,TITLE='Dtail';
  ,untulp                   STRING                   --   LABEL     a13 = FORMONLY.untulp00  TYPE CHAR           ,TITLE='Complet';
  ,ulpven                   DECIMAL(9,3)             --   LABEL     a14 = FORMONLY.ulpven00  TYPE DECIMAL(9,3)   ,TITLE='Conv.';
  ,datprx                   DATE                     --   LABEL     a16 = FORMONLY.datprx00  TYPE DATE           ,TITLE='Date'    ,FORMAT='dd-mm-yy';
  ,pxaref                   DECIMAL(10,2)            --   LABEL     a17 = FORMONLY.pxaref00  TYPE DECIMAL(10,2)  ,TITLE=' Rf.'  ,FORMAT='#,##&.&&';
  ,pxvstd                   DECIMAL(10,2)            --   LABEL     a18 = FORMONLY.pxvstd00  TYPE DECIMAL(10,2)  ,TITLE=' Std.'  ,FORMAT='#,##&.&&';
  ,pxvqte                   DECIMAL(10,2)            --   LABEL     a19 = FORMONLY.pxvqte00  TYPE DECIMAL(10,2)  ,TITLE=' Qte.'  ,FORMAT='#,##&.&&';
  ,datsys                   DATETIME YEAR TO SECOND  --   PHANTOM         FORMONLY.datsys00  TYPE DATETIME YEAR TO SECOND;
  ,prcmin                   DECIMAL(10,2)            --   PHANTOM         FORMONLY.prcmin    TYPE DECIMAL(10,2);
  ,sermrg                   INTEGER                  --   PHANTOM         FORMONLY.sermrg    TYPE INTEGER;
  ,serart                   INTEGER                  --   PHANTOM         FORMONLY.serart    TYPE INTEGER;
   END RECORD
PRIVATE TYPE tat_tlamrgmrg RECORD                    -- SCREEN RECORD sr_tlamrgmrg (attributs de sr_tlamrgcli ...)
   cligrp                   STRING
  ,numart                   STRING
  ,libart                   STRING
  ,orgart                   STRING
  ,embart                   STRING
  ,codmag                   STRING
  ,datmrg                   STRING
  ,mrgstd                   STRING
  ,mrgqte                   STRING
  ,qtemin                   STRING
  ,untven                   STRING    
  ,untuld                   STRING
  ,untulp                   STRING
  ,ulpven                   STRING
  ,datprx                   STRING
  ,pxaref                   STRING
  ,pxvstd                   STRING
  ,pxvqte                   STRING
   END RECORD
PRIVATE TYPE tsr_tlamrgcli RECORD                    -- SCREEN RECORD sr_tlamrgcli (valeurs)
   numcli                   STRING                   --   EDIT     c01 = FORMONLY.numcli01     TYPE CHAR                      ,TITLE='Numro';
  ,nomcli                   STRING                   --   LABEL    c02 = FORMONLY.nomcli01     TYPE CHAR                      ,TITLE='Nom client';
  ,grpprm                   STRING                   --   LABEL    c03 = FORMONLY.grpprm01     TYPE CHAR                      ,TITLE='Groupe';
  ,codcat                   STRING                   --   LABEL    c04 = FORMONLY.codcat01     TYPE CHAR                      ,TITLE='Catalogue';
  ,numtar                   STRING                   --   LABEL    c05 = FORMONLY.numtar01     TYPE CHAR                      ,TITLE='Tarif';
  ,flgprm                   STRING                   --   CHECKBOX c06 = FORMONLY.flgprm01     TYPE CHAR                      ,TITLE='All';
  ,datmrg                   DATE                     --   LABEL    c07 = FORMONLY.datmrg01     TYPE DATE                      ,TITLE='Date';
  ,mrgcli                   DECIMAL(6,2)             --   EDIT     c08 = FORMONLY.mrgcli01     TYPE DECIMAL(6,2)              ,TITLE='% Mrg';
  ,qtemin                   DECIMAL(9,3)             --   EDIT     c09 = FORMONLY.qtemin01     TYPE DECIMAL(9,3)              ,TITLE='Qte.Min.';
  ,utldmd                   STRING                   --   EDIT     c10 = FORMONLY.utldmd01     TYPE CHAR                      ,TITLE='Dem.',DOWNSHIFT;
  ,prxprm                   DECIMAL(10,2)            --   LABEL    c11 = FORMONLY.prxprm01     TYPE DECIMAL(10,2)             ,TITLE=' Blo',FORMAT='#,##&.&&';
  ,qteven                   DECIMAL(9,3)             --   LABEL    c12 = FORMONLY.qteven01     TYPE DECIMAL(9,3)              ,TITLE='Q.Ventes'   ,FORMAT='#,##&.&&';
  ,datprmven                DATE                     --   LABEL    c13 = FORMONLY.datprmven01  TYPE DATE                      ,TITLE='Date Prem.' ,FORMAT='dd-mm-yy';
  ,datdrnven                DATE                     --   LABEL    c14 = FORMONLY.datdrnven01  TYPE DATE                      ,TITLE='Date Drn.'  ,FORMAT='dd-mm-yy';
  ,datsys                   DATETIME YEAR TO SECOND  --   PHANTOM        FORMONLY.datsys01     TYPE DATETIME YEAR TO SECOND;
  ,sermrgcli                INTEGER                  --   PHANTOM        FORMONLY.sermrgcli    TYPE INTEGER;
  ,mrgupd                   BOOLEAN                  --   PHANTOM        FORMONLY.mrgupd01     TYPE BOOLEAN;
   END RECORD
PRIVATE TYPE tat_tlamrgcli RECORD                    -- SCREEN RECORD sr_tlamrgcli (attributs de sr_tlamrgcli ...)
   numcli                   STRING                   -- il faut exactement la mme structure car les attributs
  ,nomcli                   STRING                   -- sont lis par la position et pas le nom ...
  ,grpprm                   STRING                   
  ,codcat                   STRING                   
  ,numtar                   STRING                   
  ,flgprm                   STRING                   
  ,datmrg                   STRING                   
  ,mrgcli                   STRING                   
  ,qtemin                   STRING                   
  ,utldmd                   STRING                   
  ,prxprm                   STRING                   
  ,qteven                   STRING                   
  ,datprmven                STRING                   
  ,datdrnven                STRING
   END RECORD
PRIVATE TYPE tsr_tlamrggrp RECORD                    -- SCREEN RECORD sr_tlamrggrp (valeurs)
   grpprm                   STRING                   --   COMBOBOX d01 = FORMONLY.grpprm02     TYPE CHAR      ,UPSHIFT        ,TITLE='Groupe',INITIALIZER=load_grpprm;
  ,libgrp                   STRING                   --   LABEL    d02 = FORMONLY.libgrp02     TYPE CHAR                      ,TITLE='Description';
  ,datmrg                   DATE                     --   LABEL    d07 = FORMONLY.datmrg02     TYPE DATE                      ,TITLE='Date';
  ,mrggrp                   DECIMAL(6,2)             --   EDIT     d08 = FORMONLY.mrggrp02     TYPE DECIMAL(6,2)              ,TITLE='% Mrg';
  ,qtemin                   DECIMAL(9,3)             --   EDIT     d09 = FORMONLY.qtemin02     TYPE DECIMAL(9,3)              ,TITLE='Qte.Min.';
  ,utldmd                   STRING                   --   EDIT     d10 = FORMONLY.utldmd02     TYPE CHAR                      ,TITLE='Dem.',DOWNSHIFT;
  ,prxprm                   DECIMAL(10,2)            --   LABEL    d11 = FORMONLY.prxprm02     TYPE DECIMAL(10,2)             ,TITLE=' Blo',FORMAT='#,##&.&&';
  ,qteven                   DECIMAL(9,3)             --   LABEL    d12 = FORMONLY.qteven02     TYPE DECIMAL(9,3)              ,TITLE='Q.Ventes'   ,FORMAT='#,##&.&&';
  ,datprmven                DATE                     --   LABEL    d13 = FORMONLY.datprmven02  TYPE DATE                      ,TITLE='Date Prem.' ,FORMAT='dd-mm-yy';
  ,datdrnven                DATE                     --   LABEL    d14 = FORMONLY.datdrnven02  TYPE DATE                      ,TITLE='Date Drn.'  ,FORMAT='dd-mm-yy';
  ,datsys                   DATETIME YEAR TO SECOND  --   PHANTOM        FORMONLY.datsys02     TYPE DATETIME YEAR TO SECOND;
  ,sermrggrp                INTEGER                  --   PHANTOM        FORMONLY.sermrggrp    TYPE INTEGER;
  ,mrgupd                   BOOLEAN                  --   PHANTOM        FORMONLY.mrgupd02     TYPE BOOLEAN;
   END RECORD                                         
PRIVATE TYPE tat_tlamrggrp RECORD                    -- SCREEN RECORD sr_tlamrggrp (attributs de sr_tlamrggrp ...)
   grpprm                   STRING
  ,libgrp                   STRING                    
  ,datmrg                   STRING                    
  ,mrggrp                   STRING
  ,qtemin                   STRING
  ,utldmd                   STRING
  ,prxprm                   STRING
  ,qteven                   STRING
  ,datprmven                STRING
  ,datdrnven                STRING
   END RECORD
--****************************************************************************--
--                     TYPES POUR INTERFACE DATABASE                          --
--****************************************************************************--
PRIVATE TYPE t_ventes RECORD
   cligrp                   STRING
  ,anne                     SMALLINT
  ,primodcd                 STRING
  ,datprmven                DATE
  ,datdrnven                DATE
  ,qteliv                   DECIMAL(9,3)
   END RECORD
--****************************************************************************--
--                       VARIABLES OBJETS MODULE                              --
--****************************************************************************--
DEFINE oConnectDB           libdbutils.t_connectDB
DEFINE oTlamrg              classTlamrg.tr_tlamrg
DEFINE oTlamrgcli           classTlamrgcli.t_tlamrgcli
DEFINE oTlamrggrp           classTlamrggrp.t_tlamrggrp
--****************************************************************************--
--                         VARIABLES MODULE                                   --
--****************************************************************************--
{Variables de lien avec les ATTRIBUTES/INSTRUCTIONS de l'cran majtlamrg.per}
DEFINE FrmMrg RECORD
   numart                   INTEGER           -- EDIT     numart = FORMONLY.numart TYPE INTEGER, STYLE='saisiegras';
  ,codlst                   STRING            -- COMBOBOX codlst = FORMONLY.codlst TYPE CHAR,INITIALIZER=load_codlst, STYLE='saisiegras';
  ,codmch                   STRING            -- EDIT     codmch = FORMONLY.codmch TYPE CHAR, UPSHIFT, STYLE='saisiegras';
  ,libart                   STRING            -- EDIT     libart = FORMONLY.libart TYPE CHAR, UPSHIFT, STYLE='saisiegras';
  ,codvis                   STRING            -- COMBOBOX codvis = FORMONLY.codvis TYPE CHAR,INITIALIZER=load_codvis, STYLE='saisiegras';
  ,mrgval  DYNAMIC ARRAY OF tsr_tlamrgmrg
  ,mrgatt  DYNAMIC ARRAY OF tat_tlamrgmrg
  ,clival  DYNAMIC ARRAY OF tsr_tlamrgcli
  ,cliatt  DYNAMIC ARRAY OF tat_tlamrgcli
  ,grpval  DYNAMIC ARRAY OF tsr_tlamrggrp
  ,grpatt  DYNAMIC ARRAY OF tat_tlamrggrp
  ,mrgvalsav                tsr_tlamrgmrg
  ,mrgattsav                tat_tlamrgmrg
  ,clivalsav                tsr_tlamrgcli
  ,cliattsav                tat_tlamrgcli
  ,grpvalsav                tsr_tlamrggrp
  ,grpattsav                tat_tlamrggrp
  ,lnumart99                STRING            --EDIT lnumart99  = FORMONLY.lnumart99  TYPE CHAR          ,STYLE='labelcle'  ,NOENTRY;
  ,lmrgstd99                DECIMAL(6,2)      --EDIT lstd99     = FORMONLY.lmrgstd99  TYPE DECIMAL(12,2) ,STYLE='labelcle'  ,NOENTRY;
  ,lmrgqte99                DECIMAL(6,2)      --EDIT lqte99     = FORMONLY.lmrgqte99  TYPE DECIMAL(12,2) ,STYLE='labelcle'  ,NOENTRY;
  ,lqtemin99                DECIMAL(9,3)      --EDIT lmin99     = FORMONLY.lqtemin99  TYPE DECIMAL(12,2) ,STYLE='labelcle'  ,NOENTRY,FORMAT='##&.&&';
  ,libart99                 STRING            --EDIT libart99   = FORMONLY.libart99   TYPE CHAR          ,STYLE='labelcle'  ,NOENTRY;
  ,lserart                  STRING            --EDIT lserart    = FORMONLY.lserart    TYPE INTEGER       ,STYLE='labelcle'  ,NOENTRY;
  ,lsermrg                  STRING            --EDIT lsermrg    = FORMONLY.lsermrg    TYPE INTEGER       ,STYLE='labelcle'  ,NOENTRY;
  ,lsermrgcli               STRING            --EDIT lsermrgcli = FORMONLY.lsermrgcli TYPE INTEGER       ,STYLE='labelcle'  ,NOENTRY;
  ,lsermrggrp               STRING            --EDIT lsermrggrp = FORMONLY.lsermrggrp TYPE INTEGER       ,STYLE='labelcle'  ,NOENTRY;
   END RECORD
DEFINE Copy RECORD
   clilibart                STRING
  ,clival  DYNAMIC ARRAY OF tsr_tlamrgcli
  ,grplibart                STRING
  ,grpval  DYNAMIC ARRAY OF tsr_tlamrggrp
   END RECORD
{Variables des "positions actuelles" sur les tableaux dynamiques dclars dans le record FrmMrg}
DEFINE linMrg               INTEGER           -- mrgval/mrgatt DYNAMIC ARRAY scr_line()
DEFINE linCli               INTEGER           -- clival/cliatt DYNAMIC ARRAY scr_line()
DEFINE linGrp               INTEGER           -- grpval/grpatt DYNAMIC ARRAY scr_line()
DEFINE curMrg               INTEGER           -- mrgval/mrgatt DYNAMIC ARRAY arr_curr()
DEFINE curCli               INTEGER           -- clival/cliatt DYNAMIC ARRAY arr_curr()
DEFINE curGrp               INTEGER           -- grpval/grpatt DYNAMIC ARRAY arr_curr()
{Flag pour savoir si on est en mode Edition INPUT ou mode Tableau INPUT ARRAY}
DEFINE modeEdition          BOOLEAN = FALSE
DEFINE modeTableau          BOOLEAN = FALSE
{Variables pour faire du cache sur les historiques de vente}
DEFINE cache_histo DYNAMIC ARRAY OF RECORD
   serart                   INTEGER
  ,hiscli  DYNAMIC ARRAY OF t_ventes
  ,hisgrp  DYNAMIC ARRAY OF t_ventes
   END RECORD
{Dictionnaire des messages erreurs utiliss dans les contrles des champs input}
DEFINE errkey               STRING
DEFINE errors DICTIONARY OF RECORD
       msg                  STRING   -- message d'erreur a afficher
      ,ctx                  SMALLINT -- context erreur permet de formatter le message avec SFMT ....
      ,nxt                  STRING   -- nom du champ sur lequel il faut se positionner en cas d'erreur
       END RECORD = ('flt0001':(nxt:'CURRENT' ,ctx:0, msg:'Pas d''articles trouvs sur base des critres saisis')
                    ,'mrg0001':(nxt:'mrgstd00',ctx:1, msg:'La marge standard doit tre > %1%%.')
                    ,'mrg0002':(nxt:'mrgqte00',ctx:1, msg:'La marge quantit doit tre > %1%%.')
                    ,'mrg0003':(nxt:'qtemin00',ctx:0, msg:'La quantit minimum doit tre > 0.')
                    ,'mrg0004':(nxt:'mrgqte00',ctx:0, msg:'La marge quantit doit tre < marge standard.')
                    ,'mrg0005':(nxt:'mrgstd00',ctx:0, msg:'Si la quantit minimum est >= 1 alors la marge standard doit tre > que la marge quantit')
                    ,'mrg0006':(nxt:'mrgstd00',ctx:2, msg:'Erreur lors de la mj de la base de donnes (tlamrg) : %1')
                    ,'cli0001':(nxt:'numcli01',ctx:0, msg:'Numro de client pas trouv.')
                    ,'cli0002':(nxt:'mrgcli01',ctx:0, msg:'Il faut saisir une marge <  la marge quantit.')
                    ,'cli0003':(nxt:'qtemin01',ctx:0, msg:'Il faut saisir une quantit minimum.')
                    ,'cli0004':(nxt:'qtemin01',ctx:0, msg:'Il exite dj une rgle de marge pour cette quantit minimum.')
                    ,'cli0005':(nxt:'+CURR'   ,ctx:0, msg:'Tous les champs doivent tre renseigns')
                    ,'cli0006':(nxt:'mrgcli01',ctx:1, msg:'Erreur lors de la mj de la base de donnes (tlamrgcli) : %1')
                    ,'cli0007':(nxt:'utldmd01',ctx:0, msg:'Il faut saisir un code demandeur.')
                    ,'cli0008':(nxt:'numcli01',ctx:0, msg:'Le client appartient  un groupe PROMO.')
                    ,'grp0001':(nxt:'grpprm02',ctx:0, msg:'Code groupe pas trouv.')
                    ,'grp0002':(nxt:'mrggrp02',ctx:0, msg:'Il faut saisir une marge <  la marge quantit.')
                    ,'grp0003':(nxt:'qtemin02',ctx:0, msg:'Il faut saisir une quantit minimum.')
                    ,'grp0004':(nxt:'qtemin02',ctx:0, msg:'Il exite dj une rgle de marge pour cette quantit minimum.')
                    ,'grp0005':(nxt:'+CURR'   ,ctx:0, msg:'Tous les champs doivent tre renseigns')
                    ,'grp0006':(nxt:'mrggrp02',ctx:1, msg:'Erreur lors de la mj de la base de donnes (tlamrggrp) : %1')
                    ,'grp0007':(nxt:'utldmd02',ctx:0, msg:'Il faut saisir un code demandeur.')
                    )
{Variables de paramtrage}
DEFINE catprx               CHAR(1)

--****************************************************************************--
--                              CODE PROGRAMME                                --
--****************************************************************************--
--////////////////////////////////////////////////////////////////////////////--
--                                   MAIN                                     --
--\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\--
MAIN
  CALL glbmrgprx.init_main()
  CALL libcolors.initColors()                                                    -- initialisation des couleurs
  CALL ui.Interface.loadStyles(path:'majmrgprx')                                 -- chargement du fichier 4st
  CALL libcolors.InitStyleColors()                                               -- modification des couleurs dans le fichier 4st en fonction du theme
  CALL ui.Interface.loadActionDefaults(path:'majmrgprx')                         -- chargement fichier 4ad
  CALL ui.Interface.loadToolBar(path:'majmrgprx')                                -- chargement fichier 4tb
  CALL oConnectDB.InitDB(cname:'dbmain',db:'provencale',usr:'',psw:'',dev:FALSE) -- initialisation objet oConnectDB (dev:TRUE --> devtcp, dev:FALSE --> prd)
  CALL oConnectDB.ConnectDB()                                                    -- connexion  la DB
  CALL oTlamrgcli.init()
  CALL oTlamrggrp.init()
  CALL FrmPrg_Input()
  CALL oConnectDB.DisconnectDB()
END MAIN
--------------------------------------------------------------------------------
--////////////////////////////////////////////////////////////////////////////--
--                            Dialogue principale                             --
--\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\--
--------------------------------------------------------------------------------
FUNCTION FrmPrg_Input()
  DEFINE restartInput    BOOLEAN

  -- Ouverture cran majtlamrg.per et initialisation titre de la fentre
  OPEN WINDOW wmajtlamrg WITH FORM 'majtlamrg'
  CALL ui.Window.getCurrent().setText(cstmrgprx.getVersion(oDB:oConnectDB))
  DIALOG ATTRIBUTES(UNBUFFERED)
    ----------------------------------------------------------------
    -- Champs filtres et affichage informatif (article, serials ...)
    ----------------------------------------------------------------
    INPUT BY NAME FrmMrg.numart
                 ,FrmMrg.libart
                 ,FrmMrg.codlst
                 ,FrmMrg.codmch
                 ,FrmMrg.codvis
                 ,FrmMrg.lnumart99
                 ,FrmMrg.lmrgstd99  
                 ,FrmMrg.lmrgqte99  
                 ,FrmMrg.lqtemin99  
                 ,FrmMrg.libart99   
                 ,FrmMrg.lserart
                 ,FrmMrg.lsermrg
                 ,FrmMrg.lsermrgcli
                 ,FrmMrg.lsermrggrp  ATTRIBUTES (WITHOUT DEFAULTS=TRUE)
      BEFORE INPUT
        LET catprx = '2'                                     -- Catgorie de prix = POISSON (filtre articles sur fdamas.artpricat)
        LET FrmMrg.codvis = '1'                              -- Par dfaut articles en fdamas.visualcd = 1
        LET FrmMrg.numart = NULL                             -- Numro article par dfaut
        LET FrmMrg.libart = IIF(oConnectDB.moddev,'NORV','') -- pour faciliter les tests :) -> moddev est TRUE si provencale@devtcp
      ON ACTION filtre                                       -- voir dans 4ad raccourcis clavier
        CALL FrmMrg_tlamrg_populate()                        -- chargement du tableau en fonction du filtre
        IF curMrg = 0 THEN                                   -- curMrg contient la position actuelle dans le tableau des articles
          MESSAGE errors['flt0001'].msg
        ELSE
          NEXT FIELD datmrg00 -- on se positionne dans le tableau sr_tlamrgmrg (DISPLAY ARRAY)
        END IF
    END INPUT
    -----------------------------------------------------------------------
    -- Tableau avec les marges des prix standard/prix quantit des articles
    -----------------------------------------------------------------------
    DISPLAY ARRAY FrmMrg.mrgval TO sr_tlamrgmrg.* ATTRIBUTES(DOUBLECLICK = maj_marges)
      BEFORE DISPLAY
        IF curMrg = 0 THEN NEXT FIELD numart END IF -- si le tableau est vide on se positionne sur le champ numro article dans les filtres (INPUT)
      BEFORE ROW
        CALL FrmMrg_tlamrg_setcurrent(c:arr_curr(),l:scr_line())
      ON ACTION maj_marges
        IF curMrg = 0 THEN CONTINUE DIALOG END IF
        CALL FrmMrg_setModeEdition()
        CALL FrmMrg_tlamrg_setcurrent(c:'',l:'')
        INPUT FrmMrg.mrgval[curMrg].* WITHOUT DEFAULTS FROM sr_tlamrgmrg[linMrg].* ATTRIBUTES (UNBUFFERED)
          AFTER FIELD mrgstd00,mrgqte00,qtemin00
            IF NOT FrmMrg_tlamrg_validate(fieldTouched:FIELD_TOUCHED(sr_tlamrgmrg.*),afterRow:FALSE) THEN
              CALL DIALOG.nextField(name:errors[errkey].nxt)
            END IF
          ON ACTION ACCEPT
            IF NOT FrmMrg_tlamrg_validate(fieldTouched:FIELD_TOUCHED(sr_tlamrgmrg.*),afterRow:TRUE) THEN
              CALL DIALOG.nextField(name:errors[errkey].nxt)
            END IF
            EXIT INPUT
          ON ACTION CANCEL
            LET restartInput = FrmMrg_tlamrg_resetInput()
            EXIT INPUT
        END INPUT;
        CALL FrmMrg_razModeEdition()
        NEXT FIELD mrgstd00 -- le next field est important afin de declencher les vnements du DISPLAY pre (BEFORE ROW...)
      ON ACTION maj_tableau
        CALL DIALOG.getForm().setElementHidden(name:'paneaudroit',hidden:TRUE) -- on cache le paneau avec les dtails clients/groupes pour ne pas devoir synchroniser (vitesse)
        CALL DIALOG.getForm().findNode(tagName:'Table',name:'sr_tlamrgmrg').setAttribute(name:'unsortableColumns',value:1) -- important pour que les records ne soient pas retris dans l'INPUT ARRAY
        CALL FrmMrg_setModeTableau()
        INPUT ARRAY FrmMrg.mrgval FROM sr_tlamrgmrg.*
              ATTRIBUTES (WITHOUT DEFAULTS = TRUE, UNBUFFERED, MAXCOUNT=FrmMrg.mrgval.getLength(), DELETE ROW=FALSE) -- MAXCOUNT permet d'interdire l'ajout ...
          BEFORE INPUT
            LET restartInput = TRUE
            CALL DIALOG.setArrayAttributes(name:'sr_tlamrgmrg',attributes:FrmMrg.mrgatt) -- obligatoire car on dmarre un nouvel input si non les attributs couleurs ne seront pas appliqus
            CALL DIALOG.setCurrentRow(name:'sr_tlamrgmrg',row:curMrg) -- on se positionne dans le nouvel INPUT ARRAY sur le record du DISPLAY ARRAY pre ...
          BEFORE ROW
            CALL FrmMrg_tlamrg_setcurrent(c:arr_curr(),l:scr_line())
            CALL DIALOG.setFieldTouched(formFieldList:'sr_tlamrgmrg.*',val:FALSE)
          BEFORE FIELD mrgstd00
            IF restartInput THEN
              LET restartInput = FALSE
              CALL FrmMrg_tlamrg_setcurrent(c:arr_curr(),l:scr_line())
              CALL DIALOG.setFieldTouched(formFieldList:'sr_tlamrgmrg.*',val:FALSE)
            END IF
          AFTER FIELD mrgstd00,mrgqte00,qtemin00
            IF NOT FrmMrg_tlamrg_validate(fieldTouched:FIELD_TOUCHED(sr_tlamrgmrg.*),afterRow:FALSE) THEN
              CALL DIALOG.nextField(name:errors[errkey].nxt)
            END IF
          AFTER ROW
            IF NOT FrmMrg_tlamrg_validate(fieldTouched:FIELD_TOUCHED(sr_tlamrgmrg.*),afterRow:TRUE) THEN
              LET restartInput = FrmMrg_tlamrg_resetInput()
              NEXT FIELD mrgstd00
            END IF
          ON ACTION CANCEL
            LET restartInput = FrmMrg_tlamrg_resetInput()
            IF NOT FIELD_TOUCHED(sr_tlamrgmrg.*) THEN EXIT INPUT END IF  -- si l'utilisateur n'a rien modifi on quitte l'Input et on revient dans le DISPLAY ARRAY
            CALL DIALOG.setFieldTouched(formFieldList:'sr_tlamrgmrg.*',val:FALSE)
            NEXT FIELD mrgstd00 -- on se repositionne sur le 1er champ de la ligne ...
        END INPUT;
        CALL FrmMrg_razModeTableau()
        CALL DIALOG.setCurrentRow(name:'sr_tlamrgmrg',row:curMrg) -- on se positionne dans le DISPLAY ARRAY sur le record de l'INPUT ARRAY fils ...
        CALL DIALOG.getForm().findNode(tagName:'Table',name:'sr_tlamrgmrg').setAttribute(name:'unsortableColumns',value:0) -- on autorise le tri sur le colonnes
        CALL DIALOG.getForm().setElementHidden(name:'paneaudroit',hidden:FALSE) -- on r-affiche les autres tableaux
        NEXT FIELD mrgstd00 -- ceci permet d'executer le BEFORE ROW du DISPLAY ARRAY
      ON ACTION sup_marges
        CALL FrmMrg_tlamrg_delete()
        NEXT FIELD mrgstd00 -- ceci permet d'executer le BEFORE ROW du DISPLAY ARRAY
    END DISPLAY
    ----------------------------------------------------------------
    -- Tableau avec les marges prix promos pour des articles/clients
    ----------------------------------------------------------------
    DISPLAY ARRAY FrmMrg.clival TO sr_tlamrgcli.* ATTRIBUTES(DOUBLECLICK = maj_marges)
      BEFORE DISPLAY
        CALL DIALOG.setActionActive(name:'coller_marges',active:(Copy.clival.getLength()>0)) -- activation action 'coller_marges' si une copie en cours ...
        CALL DIALOG.setActionActive(name:'copier_marges',active:(curCli>0))                  -- activation action 'copie_marges' si une copie en cours ...
      BEFORE ROW
        CALL FrmMrg_tlamrgcli_setcurrent(c:arr_curr(),l:scr_line())
        CALL DIALOG.setActionActive(name:'copier_marges',active:(curCli>0))
        CALL FrmMrg_Razcligrp()
      ON ACTION maj_marges
        IF curCli = 0 THEN CONTINUE DIALOG END IF
        CALL FrmMrg_tlamrgcli_input(DIALOG)
      ON ACTION ajout_marges
        CALL DIALOG.insertRow(name:'sr_tlamrgcli',index:curCli)  -- on insre un nouvel lment dans le tableau, ceci ajoute automatiquenet un lment dans le tableau clival et cliatt !!!
        CALL DIALOG.setCurrentRow(name:'sr_tlamrgcli',row:curCli)   -- il faut faire ceci car sinon le arr_curr() <> DIALOG.getCurrentRow() (bug ?)
        CALL FrmMrg_tlamrgcli_setcurrent(c:arr_curr(),l:scr_line()) -- on initialise le nouveau record
        CALL FrmMrg_tlamrgcli_input(DIALOG)
        NEXT FIELD numcli01                                         -- forcer le BEFORE ROW
      ON ACTION maj_tableau  -- modification en mode tableau
        CALL DIALOG.getForm().setElementHidden(name:'gridmrggrp',hidden:TRUE) -- on cache le tableau des marges groupes
        CALL DIALOG.getForm().findNode(tagName:'Table',name:'sr_tlamrgcli').setAttribute(name:'unsortableColumns',value:1) -- important pour que les records ne soient pas retris dans l'INPUT ARRAY
        CALL FrmMrg_setModeTableau()
        INPUT ARRAY FrmMrg.clival FROM sr_tlamrgcli.*
              ATTRIBUTES (WITHOUT DEFAULTS = TRUE, UNBUFFERED, DELETE ROW=FALSE, AUTO APPEND=FALSE)
          BEFORE INPUT
            LET restartInput = TRUE
            CALL DIALOG.setArrayAttributes(name:'sr_tlamrgcli',attributes:FrmMrg.cliatt) -- obligatoire car on dmarre un nouvel input si non les attributs couleurs ne seront pas appliqus
            CALL DIALOG.setCurrentRow(name:'sr_tlamrgcli',row:curCli)                    -- on se positionne dans le nouvel INPUT ARRAY sur le record du DISPLAY ARRAY pre ...
          BEFORE ROW
            CALL FrmMrg_tlamrgcli_setcurrent(c:arr_curr(),l:scr_line()) -- on rinitialise le mode dition sur le record
            CALL DIALOG.setFieldTouched(formFieldList:'sr_tlamrgcli.*',val:FALSE) -- on raz le field touched
            LET restartInput = FALSE
          BEFORE FIELD numcli01
            IF restartInput THEN
              LET restartInput = FALSE
              CALL FrmMrg_tlamrgcli_setcurrent(c:arr_curr(),l:scr_line()) -- on rinitialise le mode dition sur le record
              CALL DIALOG.setFieldTouched(formFieldList:'sr_tlamrgcli.*',val:FALSE) -- on raz le field touched
            END IF
            IF oTlamrgcli.r.sermrgcli <> 0 THEN NEXT FIELD NEXT END IF -- champs client inaccessibles en "modification"
          BEFORE FIELD qtemin01
            IF oTlamrgcli.r.sermrgcli <> 0 THEN NEXT FIELD NEXT END IF -- champs qte mini inaccessibles en "modification"
          AFTER FIELD numcli01,mrgcli01,qtemin01,utldmd01
            IF NOT FrmMrg_tlamrgcli_validate(FIELD_TOUCHED(sr_tlamrgcli.*),afterRow:FALSE) THEN
              CALL DIALOG.nextField(name:errors[errkey].nxt)
            END IF
          AFTER ROW
            IF NOT FrmMrg_tlamrgcli_validate(FIELD_TOUCHED(sr_tlamrgcli.*),afterRow:TRUE) THEN
              LET restartInput = FrmMrg_tlamrgcli_resetInput()
              NEXT FIELD numcli01
            END IF
          ON ACTION ajout_marges
             CALL DIALOG.insertRow(name:'sr_tlamrgcli',index:curCli)     -- on insre un nouvel lment dans le tableau, ceci ajoute automatiquenet un lment dans le tableau clival et cliatt !!!
             CALL DIALOG.setCurrentRow(name:'sr_tlamrgcli',row:curCli)   -- il faut faire ceci car sinon le arr_curr() <> DIALOG.getCurrentRow()
             LET restartInput = TRUE
             NEXT FIELD numcli01
          ON ACTION CANCEL
            LET restartInput = FrmMrg_tlamrgcli_resetInput()
            IF NOT FIELD_TOUCHED(sr_tlamrgcli.*) THEN EXIT INPUT END IF  -- si l'utilisateur n'a rien modifi on quitte l'Input et on revient dans le DISPLAY ARRAY
            CALL DIALOG.setFieldTouched(formFieldList:'sr_tlamrgcli.*',val:FALSE) -- on raz le field touched
            NEXT FIELD numcli01                                                                        -- on se positionne sur le 1er champ et on attend un input de l'utilisateur
        END INPUT;
        CALL FrmMrg_razModeTableau()
        CALL DIALOG.setCurrentRow(name:'sr_tlamrgcli',row:curCli) -- on se positionne dans le DISPLAY ARRAY sur le record de l'INPUT ARRAY fils ...
        CALL DIALOG.getForm().findNode(tagName:'Table',name:'sr_tlamrgcli').setAttribute(name:'unsortableColumns',value:0) -- on autorise le tri sur le colonnes
        CALL DIALOG.getForm().setElementHidden(name:'gridmrggrp',hidden:FALSE) -- on affiche les autres tableaux
        NEXT FIELD numcli01
      ON ACTION sup_marges
        CALL FrmMrg_tlamrgcli_delete(DIALOG,'marge')
        NEXT FIELD numcli01
      ON ACTION sup_marges_all
        CALL FrmMrg_tlamrgcli_delete(DIALOG,'client')
        NEXT FIELD numcli01
      ON ACTION copier_marges
        CALL Copy.clival.clear()
        LET Copy.clilibart = FrmMrg.libart99
        CALL FrmMrg.clival.copyTo(Copy.clival)
        CALL DIALOG.setActionActive(name:'coller_marges',active:(Copy.clival.getLength()>0))
      ON ACTION coller_marges
        CALL FrmMrg_tlamrgcli_paste()
        CALL FrmMrg_tlamrgcli_populate(numcli:'')
    END DISPLAY
    -----------------------------------------------------------------------------------
    -- Tableau avec les marges prix promos pour des articles/groupes
    -----------------------------------------------------------------------------------
    DISPLAY ARRAY FrmMrg.grpval TO sr_tlamrggrp.* ATTRIBUTES(DOUBLECLICK = maj_marges)
      BEFORE DISPLAY
        CALL DIALOG.setActionActive(name:'coller_marges',active:(Copy.grpval.getLength()>0))
        CALL DIALOG.setActionActive(name:'copier_marges',active:(curGrp>0))
      BEFORE ROW
        CALL FrmMrg_tlamrggrp_setcurrent(c:arr_curr(),l:scr_line())
        CALL DIALOG.setActionActive(name:'copier_marges',active:(curGrp>0))
        CALL FrmMrg_Razcligrp()
      ON ACTION maj_marges
        IF curGrp = 0 THEN CONTINUE DIALOG END IF
        IF FrmMrg_tlamrggrp_input(DIALOG) THEN END IF           -- saisie des valeurs ...
      ON ACTION ajout_marges
        CALL DIALOG.insertRow(name:'sr_tlamrggrp',index:curGrp)     -- on insre un nouvel lment dans le tableau, ceci ajoute automatiquenet un lment dans le tableau grpval et grpatt !!!
        CALL DIALOG.setCurrentRow(name:'sr_tlamrggrp',row:curGrp)   -- il faut faire ceci car sinon le arr_curr() <> DIALOG.getCurrentRow()
        CALL FrmMrg_tlamrggrp_setcurrent(c:arr_curr(),l:scr_line()) -- on initialise le nouveau record
        IF FrmMrg_tlamrggrp_input(DIALOG) THEN END IF               -- saisie des valeurs ...
        NEXT FIELD grpprm02
      ON ACTION maj_tableau  -- modification en mode tableau
        CALL DIALOG.getForm().setElementHidden(name:'gridmrgcli',hidden:TRUE) -- on cache le tableau des marges groupes
        CALL DIALOG.getForm().findNode(tagName:'Table',name:'sr_tlamrggrp').setAttribute(name:'unsortableColumns',value:1) -- important pour que les records ne soient pas retris dans l'INPUT ARRAY
        CALL FrmMrg_setModeTableau()
        INPUT ARRAY FrmMrg.grpval FROM sr_tlamrggrp.*
              ATTRIBUTES (WITHOUT DEFAULTS = TRUE, UNBUFFERED, DELETE ROW=FALSE, AUTO APPEND=FALSE)
          BEFORE INPUT
            LET restartInput = TRUE
            CALL DIALOG.setArrayAttributes(name:'sr_tlamrggrp',attributes:FrmMrg.grpatt) -- obligatoire car on dmarre un nouvel input si non les attributs couleurs ne seront pas appliqus
            CALL DIALOG.setCurrentRow(name:'sr_tlamrggrp',row:curGrp)                    -- on se positionne dans le nouvel INPUT ARRAY sur le record du DISPLAY ARRAY pre ...
          BEFORE ROW
            CALL FrmMrg_tlamrggrp_setcurrent(c:arr_curr(),l:scr_line())
            CALL DIALOG.setFieldTouched(formFieldList:'sr_tlamrggrp.*',val:FALSE)
            LET restartInput = FALSE
          BEFORE FIELD grpprm02
            IF restartInput THEN
              LET restartInput = FALSE
              CALL FrmMrg_tlamrggrp_setcurrent(c:arr_curr(),l:scr_line()) -- on rinitialise le mode dition sur le record
              CALL DIALOG.setFieldTouched(formFieldList:'sr_tlamrggrp.*',val:FALSE) -- on raz le field touched
            END IF
            IF oTlamrggrp.r.sermrggrp <> 0 THEN NEXT FIELD NEXT END IF -- champs client et qte mini inaccessibles en "modification"
          BEFORE FIELD qtemin02
            IF oTlamrggrp.r.sermrggrp <> 0 THEN NEXT FIELD NEXT END IF -- champs client et qte mini inaccessibles en "modification"
          AFTER FIELD grpprm02,mrggrp02,qtemin02,utldmd02
            IF NOT FrmMrg_tlamrggrp_validate(FIELD_TOUCHED(sr_tlamrggrp.*),afterRow:FALSE) THEN
              CALL DIALOG.nextField(name:errors[errkey].nxt)
            END IF
          AFTER ROW
            IF NOT FrmMrg_tlamrggrp_validate(FIELD_TOUCHED(sr_tlamrggrp.*),afterRow:TRUE) THEN
              LET restartInput = FrmMrg_tlamrggrp_resetInput()
              NEXT FIELD grpprm02
            END IF
          ON ACTION ajout_marges
             CALL DIALOG.insertRow(name:'sr_tlamrggrp',index:curGrp)     -- on insre un nouvel lment dans le tableau, ceci ajoute automatiquenet un lment dans le tableau grpval et grpatt !!!
             CALL DIALOG.setCurrentRow(name:'sr_tlamrggrp',row:curGrp)   -- il faut faire ceci car sinon le arr_curr() <> DIALOG.getCurrentRow()
             LET restartInput = TRUE
             NEXT FIELD grpprm02                                         -- forcer le BEFORE ROW
          ON ACTION CANCEL
            LET restartInput = FrmMrg_tlamrggrp_resetInput()
            IF NOT FIELD_TOUCHED(sr_tlamrggrp.*) THEN EXIT INPUT END IF  -- si l'utilisateur n'a rien modifi on quitte l'Input et on revient dans le DISPLAY ARRAY
            CALL DIALOG.setFieldTouched(formFieldList:'sr_tlamrggrp.*',val:FALSE) -- on raz le field touched
            NEXT FIELD grpprm02                                                                        -- on se positionne sur le 1er champ et on attend un input de l'utilisateur
        END INPUT;
        CALL FrmMrg_razModeTableau()
        CALL DIALOG.setCurrentRow(name:'sr_tlamrggrp',row:curGrp) -- on se positionne dans le DISPLAY ARRAY sur le record de l'INPUT ARRAY fils ...
        CALL DIALOG.getForm().findNode(tagName:'Table',name:'sr_tlamrggrp').setAttribute(name:'unsortableColumns',value:0) -- on autorise le tri sur le colonnes
        CALL DIALOG.getForm().setElementHidden(name:'gridmrgcli',hidden:FALSE) -- on affiche les autres tableaux
        NEXT FIELD mrggrp02
      ON ACTION sup_marges                                      -- Demande de suppression d'une marge
        CALL FrmMrg_tlamrggrp_delete(DIALOG,'marge')
        NEXT FIELD grpprm02                                     -- forcer le BEFORE ROW
      ON ACTION sup_marges_all                                  -- Demande suppression de toutes les marges d'un client
        CALL FrmMrg_tlamrggrp_delete(DIALOG,'groupe')
        NEXT FIELD grpprm02                                     -- forcer le BEFORE ROW
      ON ACTION copier_marges
        CALL Copy.grpval.clear()
        CALL FrmMrg.grpval.copyTo(Copy.grpval)
        LET Copy.grplibart = FrmMrg.libart99
        CALL DIALOG.setActionActive(name:'coller_marges',active:(Copy.grpval.getLength()>0))
      ON ACTION coller_marges
        CALL FrmMrg_tlamrggrp_paste()
        CALL FrmMrg_tlamrggrp_populate(grpprm:'')
      END DISPLAY
    BEFORE DIALOG
      -- Liaison des "attributs affichage" aux diffrents tableaux
      CALL DIALOG.setArrayAttributes(name:'sr_tlamrgmrg',attributes:FrmMrg.mrgatt)
      CALL DIALOG.setArrayAttributes(name:'sr_tlamrgcli',attributes:FrmMrg.cliatt)
      CALL DIALOG.setArrayAttributes(name:'sr_tlamrggrp',attributes:FrmMrg.grpatt)
    ON ACTION EXIT
      EXIT DIALOG
  END DIALOG
  CLOSE WINDOW wmajtlamrg
END FUNCTION
FUNCTION FrmMrg_setModeEdition()
  LET modeEdition = TRUE
END FUNCTION
FUNCTION FrmMrg_razModeEdition()
  LET modeEdition = FALSE
END FUNCTION
FUNCTION FrmMrg_setModeTableau()
  LET modeEdition = TRUE
  LET modeTableau = TRUE
END FUNCTION
FUNCTION FrmMrg_razModeTableau()
  LET modeEdition = FALSE
  LET modeTableau = FALSE
END FUNCTION
-- Mise  jour du champ signalant si il y a des rgles client/groupe pour l'article
FUNCTION FrmMrg_Razcligrp()
  LET FrmMrg.mrgval[curMrg].cligrp = IIF(FrmMrg.clival.getLength() + FrmMrg.grpval.getLength(),'#',' ')
END FUNCTION
-- Initializer combobox voir form majtlamrg.per : formonly.codvis
FUNCTION FrmMrg_load_codvis(cmbbox ui.ComboBox)
  CALL cmbbox.addItem('0'  ,'Visu 0')
  CALL cmbbox.addItem('1'  ,'Visu 1')
  CALL cmbbox.addItem('2'  ,'Visu 2')
  CALL cmbbox.addItem('0,1','Visu 0 et 1')
  CALL cmbbox.addItem('0,1,2','Visu 0,1 et 2')
END FUNCTION
-- Initializer combobox voir form majtlamrg.per : formonly.codlst
-- Attention de faire un TRIM des valeurs dans la combobox sinon la valeur selectionne ne reste pas affiches !!!
FUNCTION FrmMrg_load_codlst(cmbbox ui.ComboBox)
  DEFINE statcd	                   STRING
  DEFINE statdes	                 STRING

  DECLARE csel_fdastd CURSOR FOR
    SELECT a.statcd,a.statdes FROM fdastd a WHERE a.langcd = 'F' AND a.statcd[1]= $catprx ORDER BY 1
  FOREACH csel_fdastd INTO statcd,statdes
    CALL cmbbox.addItem(statcd.trim(),statdes.trim())
  END FOREACH
  FREE csel_fdastd
END FUNCTION
-- Initializer combobox voir form majtlamrg.per : formonly.grpprm03
-- Attention de faire un TRIM des valeurs dans la combobox sinon la valeur selectionne ne reste pas affiches !!!
FUNCTION FrmMrg_load_grpprm(cmbbox ui.ComboBox)
  DEFINE grpprm	                   STRING
  DEFINE libgrp 	                 STRING

  DECLARE csel_fdcgrp CURSOR FOR
    SELECT a.promgr,a.grdes FROM fdcgrp a ORDER BY 1
  FOREACH csel_fdcgrp INTO grpprm,libgrp
    CALL cmbbox.addItem(grpprm.trim(),grpprm.trim())
  END FOREACH
  FREE csel_fdastd
END FUNCTION

--////////////////////////////////////////////////////////////////////////////--
-- Fonctions pour le tableau des marges standard et quantits (tlamrg)        --
--\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\--
FUNCTION FrmMrg_tlamrg_populate()
  DEFINE i                        INTEGER
  DEFINE rq                       STRING
  DEFINE rsel_tlamrg RECORD
    sermrg                        INTEGER
   ,datmrg                        DATE
   ,serart                        INTEGER
   ,mrgstd                        DECIMAL(6,2)
   ,mrgqte                        DECIMAL(6,2)
   ,qtemin                        DECIMAL(9,3)
   ,datsys                        DATETIME YEAR TO SECOND
   ,artfam                        INTEGER
   ,artnr                         INTEGER
   ,artdes1                       STRING
   ,origin                        STRING
   ,visualcd                      CHAR(1)
   ,cdpays                        STRING
   ,artdes2                       STRING
   ,emballage                     STRING
   ,storenr                       STRING
   ,untven                        STRING
   ,untuld                        STRING
   ,untulp                        STRING
   ,ulpven                        DECIMAL(9,3)
   ,nbrcli                        INTEGER
   ,nbrgrp                        INTEGER
    END RECORD
  DEFINE rsel_fdapri RECORD
    serart                        INTEGER
   ,dateff                        DATE
   ,prxref                        DECIMAL(10,4)
   ,prvstd                        DECIMAL(10,4)
   ,prvqte                        DECIMAL(10,4)
   ,qtemin                        DECIMAL(9,3)
    END RECORD

  CALL cache_histo.clear()   -- On vide le cache des historiques de vente
  CALL FrmMrg.mrgval.clear() -- On vide le tableau des marges standard/quantit et on charge les nouvelles donnes
  CALL FrmMrg.mrgatt.clear() -- On vide le tableau des attributs marges
  LET rq = 'SELECT a.sermrg'                  -- sermrg     INTEGER
        ||       ',a.datmrg'                  -- datmrg     DATE
        ||       ',b.artid '                  -- serart     INTEGER
        ||       ',a.mrgstd'                  -- mrgstd     DECIMAL(6,2)
        ||       ',a.mrgqte'                  -- mrgqte     DECIMAL(6,2)
        ||       ',a.qtemin'                  -- qtemin     DECIMAL(9,3)
        ||       ',a.datsys'                  -- datsys     DATETIME YEAR TO SECOND
        ||       ',b.artfam'                  -- artfam     INTEGER
        ||       ',b.artnr'                   -- artnr      INTEGER
        ||       ',b.artdes1'                 -- artdes1    STRING
        ||       ',b.origin'                  -- origin     STRING
        ||       ',b.visualcd'                -- visualcd   CHAR(1)
        ||       ',b.cdpays'                  -- cdpays     STRING
        ||       ',b.artdes2'                 -- artdes2    STRING
        ||       ',b.emballage'               -- emballage  STRING
        ||       ',b.storenr'                 -- storenr    STRING
        ||       ',GetUnite(b.stdunitrf)'     -- untven     STRING
        ||       ',GetUnite(t.untuld)'        -- untuld     STRING
        ||       ',GetUnite(t.untulp)'        -- untulp     STRING
        ||       ',QteUlptoVen(b.artid,1,0)'  -- ulpven     DECIMAL(9,3)
        ||       ',(SELECT COUNT(*) FROM tlamrgcli g WHERE g.serart = a.serart)' -- nbrcli INTEGER
        ||       ',(SELECT COUNT(*) FROM tlamrggrp g WHERE g.serart = a.serart)' -- nbrgrp INTEGER
        ||  ' FROM fdamas b'
        ||       ',fdasta s'
        ||       ',tlauntart t'
        ||       ',OUTER tlamrg a'
        || ' WHERE s.artfam = b.artfam'
        ||   ' AND s.artnr  = b.artnr'
        ||   ' AND s.statnr = 1'
        ||   ' AND b.artid  = a.serart'
        ||   ' AND t.serart = b.artid'
        ||   ' AND a.datmrg = (SELECT MAX(datmrg) FROM tlamrg c WHERE c.serart=a.serart)'

  VAR codart CHAR(6)   -- application des filtres sur base des valeurs saisies par l'utilisateur
    LET codart = IIF(NVL(FrmMrg.numart,0)>0,(FrmMrg.numart USING '&&&&&&'),'******')
  LET rq = rq.trim() || IIF(codart<>'******',SFMT(' AND %1 = %2 AND %3 = %4','b.artfam',codart[1],'b.artnr',codart[2,6]),' ') -- numro article
  LET rq = rq.trim() || SFMT(' AND %1 = %2','artpricat',catprx)                                                               -- catgorie de prix
  LET rq = rq.trim() || IIF(FrmMrg.codlst.getLength()>0,SFMT(' AND %1 =    "%2"'    ,'s.statcd'  ,FrmMrg.codlst.trim()),' ')  -- code liste
  LET rq = rq.trim() || IIF(FrmMrg.codmch.getLength()>0,SFMT(' AND %1 LIKE "%2%%"'  ,'b.matchcd' ,FrmMrg.codmch.trim()),' ')  -- match code
  LET rq = rq.trim() || IIF(FrmMrg.libart.getLength()>0,SFMT(' AND %1 LIKE "%%%2%%"','b.artdes1' ,FrmMrg.libart.trim()),' ')  -- code liste
  LET rq = rq.trim() || IIF(FrmMrg.codvis.getLength()>0,SFMT(' AND %1 IN   (%2)'    ,'b.visualcd',FrmMrg.codvis.trim()),' ')  -- code visualcd
  LET rq = rq.trim() || ' ORDER BY b.artfam,b.artnr,datmrg DESC' -- application ordre de tri select

  DECLARE csel_tlamrg CURSOR FROM rq
  LET rq = ' IN (0' -- Pour des raisons de performances on construit une seule requte pour chercher les prix actuels (fdapri)
  FOREACH csel_tlamrg INTO rsel_tlamrg.*
    LET rq = rq.trim() || ',' || (rsel_tlamrg.serart USING '<<<<<<<<&')
    LET FrmMrg.mrgval[i:=i+1].datmrg = rsel_tlamrg.datmrg
    LET FrmMrg.mrgval[i].numart      = SFMT ('%1%2',(rsel_tlamrg.artfam USING '&'),(rsel_tlamrg.artnr USING '&&&&&'))
    LET FrmMrg.mrgval[i].libart      = rsel_tlamrg.artdes1
    LET FrmMrg.mrgval[i].orgart      = rsel_tlamrg.origin
    LET FrmMrg.mrgval[i].embart      = rsel_tlamrg.emballage
    LET FrmMrg.mrgval[i].codmag      = rsel_tlamrg.storenr
    LET FrmMrg.mrgval[i].untven      = rsel_tlamrg.untven
    LET FrmMrg.mrgval[i].untuld      = rsel_tlamrg.untuld
    LET FrmMrg.mrgval[i].untulp      = rsel_tlamrg.untulp
    LET FrmMrg.mrgval[i].ulpven      = rsel_tlamrg.ulpven
    LET FrmMrg.mrgval[i].mrgstd      = rsel_tlamrg.mrgstd
    LET FrmMrg.mrgval[i].mrgqte      = rsel_tlamrg.mrgqte
    LET FrmMrg.mrgval[i].qtemin      = rsel_tlamrg.qtemin
    LET FrmMrg.mrgval[i].datsys      = rsel_tlamrg.datsys
    LET FrmMrg.mrgval[i].prcmin      = NULL
    LET FrmMrg.mrgval[i].sermrg      = NVL(rsel_tlamrg.sermrg,0)
    LET FrmMrg.mrgval[i].serart      = rsel_tlamrg.serart
    LET FrmMrg.mrgval[i].cligrp      = IIF((rsel_tlamrg.nbrcli+rsel_tlamrg.nbrgrp)>0,'#',' ')
    LET FrmMrg.mrgatt[i].numart      = IIF(rsel_tlamrg.visualcd=0,cvvbJaune,IIF(rsel_tlamrg.visualcd=2,cvvbRouge,'')) -- Attributs affichage
    LET FrmMrg.mrgatt[i].libart      = FrmMrg.mrgatt[i].numart
    IF rsel_tlamrg.sermrg IS NOT NULL THEN   -- on test NULL car la table tlamrg est OUTER dans le select de base
      IF rsel_tlamrg.untven <> rsel_tlamrg.untulp THEN
        IF rsel_tlamrg.qtemin < rsel_tlamrg.ulpven THEN
          LET FrmMrg.mrgatt[i].qtemin = cbasRouge
          LET FrmMrg.mrgatt[i].ulpven = cbasRouge
        END IF
      END IF
    END IF
  END FOREACH
  FREE csel_tlamrg
  LET rq = rq.trim() || ')'
  LET curMrg = IIF(i>0,1,0)
  IF curMrg = 0 THEN RETURN END IF
  -- Si on a trouv des articles ont va chercher les prix actuels dans fdapri (into rsel_fdapri)
  LET rq = 'SELECT b.artid,a.valdate,a.priceref,a.pricesta,a.priceqty,a.qtymin'
        ||  ' FROM fdapri a,fdamas b'
        || ' WHERE a.artfam = b.artfam'
        ||   ' AND a.artnr  = b.artnr'
        ||   ' AND b.artid  ' || rq.trim()               -- rq : IN (0,.....) de serart
        ||   ' AND valdate  = (SELECT MAX(valdate) '
        ||                     ' FROM fdapri p '
        ||                    ' WHERE a.artfam = p.artfam'
        ||                      ' AND a.artnr  = p.artnr'
        ||                      ' AND valdate <= TODAY'
        ||                      ' AND (p.pricesta <> 0 OR p.priceqty <> 0))'
        || ' ORDER BY b.artid,a.valdate'
  DECLARE csel_fdapri CURSOR FROM rq
  FOREACH csel_fdapri INTO rsel_fdapri.*
    IF ((i:=FrmMrg.mrgval.search('serart',rsel_fdapri.serart))=0) THEN CONTINUE FOREACH END IF
    LET FrmMrg.mrgval[i].datprx = rsel_fdapri.dateff
    LET FrmMrg.mrgval[i].pxaref = rsel_fdapri.prxref
    LET FrmMrg.mrgval[i].pxvstd = rsel_fdapri.prvstd
    LET FrmMrg.mrgval[i].pxvqte = rsel_fdapri.prvqte
  END FOREACH
  FREE csel_fdapri
END FUNCTION
FUNCTION FrmMrg_tlamrg_resetInput() RETURNS BOOLEAN
  LET FrmMrg.mrgval[curMrg] = FrmMrg.mrgvalsav
  LET FrmMrg.mrgatt[curMrg] = FrmMrg.mrgattsav
  RETURN TRUE
END FUNCTION
FUNCTION FrmMrg_tlamrg_setcurrent(c INTEGER,l INTEGER)
  LET curMrg = IIF(c IS NOT NULL,c,curMrg)
  LET linMrg = IIF(l IS NOT NULL,l,linMrg)
  LET FrmMrg.lnumart99   = FrmMrg.mrgval[curMrg].numart
  LET FrmMrg.lmrgstd99   = FrmMrg.mrgval[curMrg].mrgstd
  LET FrmMrg.lmrgqte99   = FrmMrg.mrgval[curMrg].mrgqte
  LET FrmMrg.lqtemin99   = FrmMrg.mrgval[curMrg].qtemin
  LET FrmMrg.libart99    = FrmMrg.mrgval[curMrg].libart
  LET FrmMrg.lserart     = FrmMrg.mrgval[curMrg].serart
  LET FrmMrg.lsermrg     = IIF(FrmMrg.mrgval[curMrg].sermrg<>0,FrmMrg.mrgval[curMrg].sermrg,'')
  LET FrmMrg.lsermrgcli  = NULL
  LET FrmMrg.lsermrggrp  = NULL
  LET oTlamrg.sermrg     = FrmMrg.mrgval[curMrg].sermrg
  LET oTlamrg.serart     = FrmMrg.mrgval[curMrg].serart
  IF NOT modeTableau THEN
    CALL FrmMrg_tlamrgcli_populate(numcli:'')
    CALL FrmMrg_tlamrggrp_populate(grpprm:'')
    CALL FrmMrg_Razcligrp()
  END IF
  LET FrmMrg.mrgvalsav  = FrmMrg.mrgval[curMrg] -- on sauvegarde une copie du record en cours en cas de CANCEL (valeurs)
  LET FrmMrg.mrgattsav  = FrmMrg.mrgatt[curMrg] -- on sauvegarde une copie du record en cours en cas de CANCEL (attributs)
  -- Initialiser les valeurs par dfauts
  IF modeEdition THEN
    LET FrmMrg.mrgval[curMrg].datmrg = IIF(FrmMrg.mrgval[curMrg].datmrg IS NULL,TODAY,FrmMrg.mrgval[curMrg].datmrg)
  END IF
END FUNCTION
FUNCTION FrmMrg_tlamrg_validate(fieldTouched BOOLEAN,afterRow BOOLEAN) RETURNS BOOLEAN
  LET errkey = ''
  IF (modeTableau) AND (NOT fieldTouched) THEN RETURN IIF(afterRow,FrmMrg_tlamrg_resetInput(),TRUE) END IF
  IF afterRow THEN
    CASE fgl_dialog_getfieldname() -- On force la rcupration de la valeur du champ dans le cas de afterRow car l'after field n'a pas t dclench
      WHEN 'mrgstd00' LET FrmMrg.mrgval[curMrg].mrgstd = fgl_dialog_getbuffer()
      WHEN 'mrgqte00' LET FrmMrg.mrgval[curMrg].mrgqte = fgl_dialog_getbuffer()
      WHEN 'qtemin00' LET FrmMrg.mrgval[curMrg].qtemin = fgl_dialog_getbuffer()
    END CASE
  END IF
  CASE
    WHEN modeTableau AND
         FrmMrg.mrgval[curMrg].mrgstd IS NULL AND
         FrmMrg.mrgval[curMrg].mrgqte IS NULL AND
         FrmMrg.mrgval[curMrg].qtemin IS NULL
         RETURN TRUE
    WHEN NVL(FrmMrg.mrgval[curMrg].mrgstd,0) < FrmMrg.mrgval[curMrg].prcmin LET errkey = 'mrg0001'
    WHEN NVL(FrmMrg.mrgval[curMrg].mrgqte,0) < FrmMrg.mrgval[curMrg].prcmin LET errkey = 'mrg0002'
    WHEN FrmMrg.mrgval[curMrg].mrgstd        < FrmMrg.mrgval[curMrg].mrgqte LET errkey = 'mrg0004'
    WHEN NVL(FrmMrg.mrgval[curMrg].qtemin,0) <= 0                           LET errkey = 'mrg0003'
    WHEN FrmMrg.mrgval[curMrg].mrgstd = FrmMrg.mrgval[curMrg].mrgqte AND
         FrmMrg.mrgval[curMrg].qtemin <> 1                                  LET errkey = 'mrg0005'
    WHEN afterRow
      LET oTlamrg.sermrg = FrmMrg.mrgval[curMrg].sermrg
      LET oTlamrg.datmrg = FrmMrg.mrgval[curMrg].datmrg
      LET oTlamrg.serart = FrmMrg.mrgval[curMrg].serart
      LET oTlamrg.mrgstd = FrmMrg.mrgval[curMrg].mrgstd
      LET oTlamrg.mrgqte = FrmMrg.mrgval[curMrg].mrgqte
      LET oTlamrg.qtemin = FrmMrg.mrgval[curMrg].qtemin
      LET oTlamrg.datsys = FrmMrg.mrgval[curMrg].datsys
      IF oTlamrg.dbupdate() THEN
        LET FrmMrg.mrgval[curMrg].sermrg = oTlamrg.sermrg
        LET FrmMrg.mrgatt[curMrg].datmrg = cvvrLime
        LET FrmMrg.mrgatt[curMrg].mrgstd = cvvrLime
        LET FrmMrg.mrgatt[curMrg].mrgqte = cvvrLime
        LET FrmMrg.mrgatt[curMrg].qtemin = cvvrLime
        RETURN TRUE
      END IF
      LET errkey = 'mrg0006'
  END CASE
  CASE errors[errkey].ctx
    WHEN 0 ERROR errors[errkey].msg
    WHEN 1 ERROR SFMT(errors[errkey].msg,FrmMrg.mrgval[curMrg].prcmin)
    WHEN 2 ERROR SFMT(errors[errkey].msg,FrmMrg.mrgval[curMrg].prcmin)
    WHEN 3 ERROR SFMT(errors[errkey].msg,sqlca.sqlerrm)
  END CASE
  RETURN (errkey IS NULL)
END FUNCTION
FUNCTION FrmMrg_tlamrg_delete()
  IF fgl_winQuestion('Confirmation','tes-vous certain de vouloir effacer la rgle de marge article ?','Non','Non|Oui','fa-var-quest',0) = 'Oui' THEN
    IF NOT oTlamrg.dbdelete() THEN
      ERROR SFMT(errors['mrg0006'].msg,sqlca.sqlerrm)
      RETURN
    END IF
    -- On nettoie les valeurs dans les tableaux en mmoire ...
    LET FrmMrg.mrgval[curMrg].sermrg = 0
    INITIALIZE FrmMrg.mrgval[curMrg].datmrg THRU FrmMrg.mrgval[curMrg].qtemin TO NULL
    INITIALIZE FrmMrg.mrgatt[curMrg].datmrg THRU FrmMrg.mrgatt[curMrg].qtemin TO NULL
  END IF
END FUNCTION

--////////////////////////////////////////////////////////////////////////////--
-- Fonctions pour gestion du tableau des marges par clients (tlamrgcli)       --
--\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\--
{Chargement du tableau des prix bloqus clients sur base de l'article courant (curMrg)}
FUNCTION FrmMrg_tlamrgcli_populate(numcli STRING)
  DEFINE i                        INTEGER = 0
  DEFINE j                        INTEGER = 0
  DEFINE k                        INTEGER = 0
  DEFINE l1                       INTEGER = 0
  DEFINE l2                       INTEGER = 0
  DEFINE rq                       STRING
  DEFINE rsel_tlamrgcli RECORD
     sermrgcli                    INTEGER
    ,serart                       INTEGER
    ,datmrg                       DATE
    ,numcli                       STRING
    ,mrgcli                       DECIMAL(6,2)
    ,qtemin                       DECIMAL(10,4)
    ,utldmd                       STRING
    ,datsys                       DATETIME YEAR TO SECOND
    ,nomcli1                      STRING  
    ,nomcli2                      STRING  
    ,flgprm                       STRING  
    ,grpprm                       STRING  
    ,codcat                       STRING  
    ,numtarmas                    STRING  
    ,numtarapg                    STRING  
     END RECORD

  LET k = cache_histo.search('serart', FrmMrg.mrgval[curMrg].serart)
  IF numcli IS NULL THEN
    CALL FrmMrg.clival.clear() -- On vide le tableau des marges lies aux clients et on charge les nouvelles donnes
    CALL FrmMrg.cliatt.clear() -- On vide le tableau des attributs
    LET rq = 'SELECT a.sermrgcli'      -- sermrgcli     INTEGER
          ||       ',a.serart'         -- serart        INTEGER
          ||       ',a.datmrg'         -- datmrg        DATE
          ||       ',a.numcli'         -- numcli        STRING
          ||       ',a.mrgcli'         -- mrgcli        DECIMAL(6,2)
          ||       ',a.qtemin'         -- qtemin        DECIMAL(10,4)
          ||       ',a.utldmd'         -- utldmd        STRING
          ||       ',a.datsys'         -- datsys        DATETIME YEAR TO SECOND
          ||       ',b.custname'       -- nomcli1       STRING  
          ||       ',b.custname2'      -- nomcli2       STRING  
          ||       ',c.promall'        -- flgprm        STRING  
          ||       ',c.promgr'         -- grpprm        STRING  
          ||       ',c.codcat'         -- codcat        STRING  
          ||       ',c.custpricd'      -- numtarmas     STRING  
          ||       ',g.custpricd'      -- numtarapg     STRING
          ||  ' FROM tlamrgcli a'
          ||       ',OUTER fdecus b'
          ||       ',OUTER fdcmas c'
          ||       ',OUTER fdcapg g'
          || ' WHERE a.numcli = b.custnr'
          ||   ' AND a.numcli = c.custnr'
          ||   ' AND a.numcli = g.custnr'
          ||   ' AND g.artpricat = "' || catprx || '"'
          ||   ' AND a.datmrg = (SELECT MAX(datmrg) FROM tlamrgcli d WHERE d.numcli=a.numcli AND d.serart=a.serart AND a.qtemin = d.qtemin)'
    LET rq = rq.trim(),' AND a.serart=' || FrmMrg.mrgval[curMrg].serart
    LET rq = rq.trim(),' ORDER BY a.numcli,a.qtemin'
    DECLARE csel_tlamrgcli CURSOR FROM rq
    LET rq = '("0"' -- Pour des raisons de performances on construit une seule requte pour chercher les statistiques des ventes
    FOREACH csel_tlamrgcli INTO rsel_tlamrgcli.*
      -- Si le client n'est pas dans le cache ...
      IF k = 0 OR cache_histo[k].hiscli.search('cligrp',rsel_tlamrgcli.numcli) = 0 THEN
        LET rq = rq.trim() || SFMT(',"%1"',rsel_tlamrgcli.numcli CLIPPED)
      END IF
      LET FrmMrg.clival[i:=i+1].sermrgcli = rsel_tlamrgcli.sermrgcli
      LET FrmMrg.clival[i].datmrg         = rsel_tlamrgcli.datmrg
      LET FrmMrg.clival[i].mrgcli         = rsel_tlamrgcli.mrgcli
      LET FrmMrg.clival[i].qtemin         = rsel_tlamrgcli.qtemin
      LET FrmMrg.clival[i].utldmd         = rsel_tlamrgcli.utldmd
      LET FrmMrg.clival[i].datsys         = rsel_tlamrgcli.datsys
      LET FrmMrg.clival[i].prxprm         = FrmMrg.mrgval[curMrg].pxaref * (1+(rsel_tlamrgcli.mrgcli/100))
      LET FrmMrg.clival[i].numcli         = rsel_tlamrgcli.numcli
      LET FrmMrg.clival[i].nomcli         = rsel_tlamrgcli.nomcli1
      LET FrmMrg.clival[i].flgprm         = rsel_tlamrgcli.flgprm
      LET FrmMrg.clival[i].grpprm         = rsel_tlamrgcli.grpprm
      LET FrmMrg.clival[i].codcat         = rsel_tlamrgcli.codcat
      LET FrmMrg.clival[i].numtar         = IIF(rsel_tlamrgcli.numtarapg IS NOT NULL,rsel_tlamrgcli.numtarapg,rsel_tlamrgcli.numtarmas)
      LET FrmMrg.clival[i].mrgupd         = FALSE
      LET FrmMrg.cliatt[i].numtar         = IIF(rsel_tlamrgcli.numtarapg IS NOT NULL,cvvrCyan,IIF(rsel_tlamrgcli.numtarmas IS NOT NULL,cvvrJaune,''))
      LET FrmMrg.cliatt[i].qtemin         = IIF(rsel_tlamrgcli.qtemin >=1,cwcrFramboise,'')
      LET FrmMrg.cliatt[i].nomcli         = cbasRouge
      -- mj prcmin possible dans tableau des marges std/qte
      LET FrmMrg.mrgval[curMrg].prcmin = IIF(FrmMrg.mrgval[curMrg].prcmin IS NULL OR rsel_tlamrgcli.mrgcli<FrmMrg.mrgval[curMrg].prcmin,rsel_tlamrgcli.mrgcli,FrmMrg.mrgval[curMrg].prcmin)
    END FOREACH
    FREE csel_tlamrgcli
    LET FrmMrg.mrgval[curMrg].prcmin = IIF(FrmMrg.mrgval[curMrg].prcmin IS NULL,20,FrmMrg.mrgval[curMrg].prcmin)
    FREE csel_tlamrgcli
    LET rq = rq.trim() || ')'
    LET curCli = IIF(i>0,1,0)
    IF curCli = 0 THEN RETURN END IF
  ELSE
    LET rq = SFMT('("%1")',numcli)
  END IF
  -- Charger le tableau des prix bloqus sur base d'un ou de plusieurs clients
  -- le paramtre rq contient un chane de type IN avec le ou les numros de clients '("8905","8903",...)'
  -- il y a un tableau "cache" pour ne pas faire les requtes SQL plusieurs fois
  IF k > 0 THEN
    LET rq = IIF((numcli IS NOT NULL AND j:=cache_histo[k].hiscli.search('cligrp',numcli) > 0),'',rq)
    LET rq = IIF(rq='("0")','',rq)
  END IF
  IF rq IS NOT NULL THEN
    -- Si pas de cache chercher les valeurs dans la DB ...
    LET k = IIF(k=0,cache_histo.getLength()+1,k)
    LET cache_histo[k].serart = FrmMrg.mrgval[curMrg].serart
    LET rq = 'SELECT c.custnr,YEAR(execdate),CASE WHEN NVL(serprm,0)<>0 THEN "2" ELSE "0" END,MIN(execdate),MAX(execdate),SUM(delqty)'
         ||   ' FROM sstoarlp a,sstamas b,sstcpia c'
         ||  ' WHERE a.artid  = b.artid'
         ||    ' AND a.custid = c.custid'
         ||    ' AND b.artidp = '  || FrmMrg.mrgval[curMrg].serart
         ||    ' AND c.custnr IN ' || rq.trim()
         ||    ' AND execdate BETWEEN TODAY-365 AND TODAY'
         ||  ' GROUP BY 1,2,3'
         ||  ' UNION '  
         ||  'SELECT c.custnr,YEAR(execdate),CASE WHEN NVL(serprm,0)<>0 THEN "2" ELSE "0" END,MIN(execdate),MAX(execdate),SUM(delqty)'
         ||   ' FROM sstoarl a,sstamas b,sstcpia c'
         ||  ' WHERE a.artid = b.artid'
         ||    ' AND a.custid = c.custid'
         ||    ' AND artidp   = '  || FrmMrg.mrgval[curMrg].serart
         ||    ' AND c.custnr IN ' || rq.trim()
         ||    ' AND execdate BETWEEN TODAY-365 AND TODAY'
         ||  ' GROUP BY 1,2,3'
         ||  ' UNION '
         ||  'SELECT c.custnr,YEAR(execdate),CASE WHEN NVL(serprm,0)<>0 THEN "2" ELSE "0" END,MIN(execdate),MAX(execdate),SUM(delqty*facncr)'
         ||   ' FROM fdoarl a,fdomas c'
         ||  ' WHERE a.ordrf = c.ordrf'
         ||    ' AND a.linestat = 7'
         ||    ' AND a.serart = '  || FrmMrg.mrgval[curMrg].serart
         ||    ' AND a.datliv >= TODAY-180'
         ||    ' AND c.ordstat = 7'
         ||    ' AND c.custnr IN ' || rq.trim()
         ||    ' AND c.execdate >= TODAY-180'
         ||  ' GROUP BY 1,2,3'
    DECLARE csel_hiscli CURSOR FROM rq
    LET j = IIF(j=0,cache_histo[k].hiscli.getLength(),j)
    FOREACH csel_hiscli INTO cache_histo[k].hiscli[j:=j+1].*
    END FOREACH
    FREE csel_hiscli
    CALL cache_histo[k].hiscli.deleteElement(j) -- attention il faut supprimer le dernier lment a cause de la syntaxe [j:=j+1] car le j est incrment avant le FOREACH
  END IF
  -- on met a jour le tableau cran (clival) sur base des donnes du tableau cache (cache_histo)
  LET l1 = FrmMrg.clival.getLength()
  FOR i = 1 TO l1
    LET FrmMrg.clival[i].qteven = 0
    LET l2 = cache_histo[k].hiscli.getLength()
    FOR j = 1 TO l2
      IF FrmMrg.clival[i].numcli = cache_histo[k].hiscli[j].cligrp THEN
        LET FrmMrg.clival[i].datprmven = IIF(FrmMrg.clival[i].datprmven IS NULL,cache_histo[k].hiscli[j].datprmven,FrmMrg.clival[i].datprmven)
        LET FrmMrg.clival[i].datdrnven = cache_histo[k].hiscli[j].datdrnven
        LET FrmMrg.clival[i].qteven    = FrmMrg.clival[i].qteven + cache_histo[k].hiscli[j].qteliv
        LET FrmMrg.cliatt[i].nomcli    = IIF(FrmMrg.clival[i].datdrnven+6 UNITS MONTH>TODAY,'',FrmMrg.cliatt[i].nomcli)
      END IF
    END FOR
  END FOR
END FUNCTION
FUNCTION FrmMrg_tlamrgcli_input(d ui.Dialog)
  DEFINE flgadd               BOOLEAN
  DEFINE flglstfld            BOOLEAN

  IF oTlamrg.sermrg = 0 THEN END IF -- si pas marge std/qte on autorise pas l'accs aux marges clients
  CALL FrmMrg_setModeEdition()
  INPUT FrmMrg.clival[curCli].* WITHOUT DEFAULTS FROM sr_tlamrgcli[linCli].* ATTRIBUTES(UNBUFFERED)
    BEFORE INPUT
      CALL d.setFieldActive('sr_tlamrgmrg.*',FALSE) -- on interdit accs au tabelau des marges std/qte
      CALL d.setFieldActive('sr_tlamrggrp.*',FALSE) -- on interdit accs au tableau des marges groupe
      LET flgadd    = (oTlamrgcli.r.sermrgcli == 0)
      LET flglstfld = NOT flgadd                    -- en mode "insert" le flglstfld est positionn a FALSE pour obliger la saisie de tous les champs
      LET FrmMrg.clival[curCli].datmrg = IIF(flgadd,TODAY,FrmMrg.clival[curCli].datmrg)
    AFTER INPUT
      CALL d.setFieldActive('sr_tlamrgmrg.*',TRUE)  -- on rtabli accs au marge std/qte
      CALL d.setFieldActive('sr_tlamrggrp.*',TRUE)  -- on rtabli accs au marge groupe
    BEFORE FIELD numcli01,qtemin01
      IF NOT flgadd THEN NEXT FIELD NEXT END IF -- champs client et qte mini inaccessibles en "modification"
    BEFORE FIELD utldmd01                       -- lorsqu'on rentre dans le dernier champ on le signal (flglstfld)
      LET FrmMrg.clival[curCli].utldmd = IIF(FrmMrg.clival[curCli].utldmd IS NULL,oTlamrgcli.r.utldmd,FrmMrg.clival[curCli].utldmd)
      LET flglstfld = TRUE
    AFTER FIELD numcli01,mrgcli01,qtemin01,utldmd01
      IF NOT FrmMrg_tlamrgcli_validate(FIELD_TOUCHED(sr_tlamrgcli.*),afterRow:FALSE) THEN
        CALL DIALOG.nextField(name:errors[errkey].nxt)
      END IF
    ON ACTION ACCEPT
      IF NOT flglstfld THEN
        ERROR errors['cli0005'].msg
      ELSE
        IF FrmMrg_tlamrgcli_validate(FIELD_TOUCHED(sr_tlamrgcli.*),afterRow:TRUE) THEN EXIT INPUT END IF
      END IF
    ON ACTION CANCEL -- Si on abandonne en mode cration on supprime l'lment du tableau
      LET flgadd = NOT FrmMrg_tlamrgcli_resetInput()
      EXIT INPUT
  END INPUT
  CALL FrmMrg_razModeEdition()
END FUNCTION
FUNCTION FrmMrg_tlamrgcli_resetInput() RETURNS BOOLEAN
  IF oTlamrgcli.r.sermrgcli = 0 THEN
    CALL FrmMrg.clival.deleteElement(curCli)
    CALL FrmMrg.cliatt.deleteElement(curCli)
  ELSE
    LET FrmMrg.clival[curCli] = FrmMrg.clivalsav
    LET FrmMrg.cliatt[curCli] = FrmMrg.cliattsav
  END IF
  RETURN TRUE
END FUNCTION
FUNCTION FrmMrg_tlamrgcli_setcurrent(c INTEGER, l INTEGER)
  LET curCli = IIF(c IS NOT NULL,c,curCli)
  LET linCli = IIF(l IS NOT NULL,l,linCli)
  LET FrmMrg.lsermrgcli      = FrmMrg.clival[curCli].sermrgcli
  LET oTlamrgcli.r.sermrgcli = NVL(FrmMrg.clival[curCli].sermrgcli,0)
  LET FrmMrg.clival[curCli].datmrg = IIF(oTlamrgcli.r.sermrgcli=0,TODAY,FrmMrg.clival[curCli].datmrg)
  LET FrmMrg.lsermrggrp   = NULL
  LET oTlamrgcli.r.numcli = FrmMrg.clival[curCli].numcli
  LET oTlamrgcli.r.utldmd = FrmMrg.clival[curCli].utldmd
  LET FrmMrg.clivalsav    = FrmMrg.clival[curCli] -- on sauvegarde une copie du record en cours (valeurs)
  LET FrmMrg.cliattsav    = FrmMrg.cliatt[curCli] -- on sauvegarde une copie du record en cours (attributs)
  -- obligation de rafraichir car le champ appartient au Dialog
  DISPLAY FrmMrg.lsermrgcli TO lsermrgcli
  DISPLAY FrmMrg.lsermrggrp TO lsermrggrp
END FUNCTION
FUNCTION FrmMrg_tlamrgcli_validate(fieldTouched BOOLEAN,afterRow BOOLEAN) RETURNS BOOLEAN
  DEFINE fldnam     STRING

  LET errkey = ''
  IF (modeTableau) AND (NOT fieldTouched) THEN RETURN IIF(afterRow,FrmMrg_tlamrgcli_resetInput(),TRUE) END IF  -- En mode tableau (INPUT ARRAY) si le champ n'a pas t "touch" on ne fait rien
  LET fldnam = fgl_dialog_getfieldname()
  IF afterRow THEN
    CASE fldnam -- On force la rcupration de la valeur du champ dans le cas de afterRow car l'after field n'a pas t dclench
      WHEN 'numcli01' LET FrmMrg.clival[curCli].numcli = fgl_dialog_getbuffer()
      WHEN 'mrgcli01' LET FrmMrg.clival[curCli].mrgcli = fgl_dialog_getbuffer()
      WHEN 'qtemin01' LET FrmMrg.clival[curCli].qtemin = fgl_dialog_getbuffer()
      WHEN 'utldmd01' LET FrmMrg.clival[curCli].utldmd = fgl_dialog_getbuffer()
    END CASE
    LET fldnam = 'all'
  END IF
  CASE
    WHEN fldnam IN ('all','numcli01') AND
         NOT FrmMrg_tlamrgcli_setclient(refreshVentes:(fldnam<>'all'))  LET errkey = 'cli0001'
    WHEN fldnam IN ('all','numcli01') AND
         FrmMrg.clival[curCli].grpprm <> 'ALL'                          LET errkey = 'cli0008'
    WHEN fldnam IN ('all','mrgcli01') AND
         (FrmMrg.clival[curCli].mrgcli IS NULL OR
          FrmMrg.clival[curCli].mrgcli >= FrmMrg.mrgval[curMrg].mrgqte) LET errkey = 'cli0002'
    WHEN fldnam IN ('all','qtemin01') AND
         FrmMrg.clival[curCli].qtemin IS NULL                           LET errkey = 'cli0003'
    WHEN fldnam IN ('all','qtemin01') AND
         NOT FrmMrg_tlamrgcli_setqtemin()                               LET errkey = 'cli0004'
    WHEN fldnam IN ('all','utldmd01') AND
         NVL(FrmMrg.clival[curCli].utldmd,' ') = ' '                    LET errkey = 'cli0007'
    WHEN afterRow
      LET oTlamrgcli.r.serart          = FrmMrg.mrgval[curMrg].serart
      LET oTlamrgcli.r.datmrg          = FrmMrg.clival[curCli].datmrg
      LET oTlamrgcli.r.mrgcli          = FrmMrg.clival[curCli].mrgcli
      LET oTlamrgcli.r.qtemin          = FrmMrg.clival[curCli].qtemin
      LET oTlamrgcli.r.utldmd          = FrmMrg.clival[curCli].utldmd
      LET FrmMrg.clival[curCli].prxprm = FrmMrg.mrgval[curMrg].pxaref * (1+(oTlamrgcli.r.mrgcli/100))
      IF oTlamrgcli.dbupdate() THEN
        LET FrmMrg.clival[curCli].sermrgcli = oTlamrgcli.r.sermrgcli
        LET FrmMrg.cliatt[curCli].datmrg    = cvvrLime
        LET FrmMrg.cliatt[curCli].mrgcli    = cvvrLime
        LET FrmMrg.cliatt[curCli].qtemin    = cvvrLime
        LET FrmMrg.cliatt[curCli].utldmd    = cvvrLime
        RETURN TRUE
      END IF
      LET errkey = 'cli0006'
  END CASE
  CASE errors[errkey].ctx
    WHEN 0 ERROR errors[errkey].msg
    WHEN 1 ERROR SFMT(errors[errkey].msg,sqlca.sqlerrm)
  END CASE
  RETURN (errkey IS NULL)
END FUNCTION
FUNCTION FrmMrg_tlamrgcli_setclient(refreshVentes BOOLEAN) RETURNS BOOLEAN
  LET oTlamrgcli.catprx = catprx
  LET oTlamrgcli.r.numcli = FrmMrg.clival[curCli].numcli
  CALL oTlamrgcli.client()
  LET FrmMrg.clival[curCli].nomcli = oTlamrgcli.c.nomcli1
  LET FrmMrg.clival[curCli].flgprm = oTlamrgcli.c.flgprm
  LET FrmMrg.clival[curCli].grpprm = oTlamrgcli.c.grpprm
  LET FrmMrg.clival[curCli].codcat = oTlamrgcli.c.codcat
  LET FrmMrg.clival[curCli].numtar = IIF(oTlamrgcli.c.numtarapg IS NOT NULL,oTlamrgcli.c.numtarapg,oTlamrgcli.c.numtarmas)
  LET FrmMrg.cliatt[curCli].numtar = IIF(oTlamrgcli.c.numtarapg IS NOT NULL,cvvrCyan,IIF(oTlamrgcli.c.numtarmas IS NOT NULL,cvvrJaune,''))
  IF oTlamrgcli.c.nomcli1 IS NOT NULL AND refreshVentes THEN
    CALL FrmMrg_tlamrgcli_populate(numcli:oTlamrgcli.r.numcli)
  END IF
  RETURN (oTlamrgcli.c.nomcli1 IS NOT NULL)
END FUNCTION
FUNCTION FrmMrg_tlamrgcli_setqtemin() RETURNS BOOLEAN
  LET oTlamrgcli.r.serart    = FrmMrg.mrgval[curMrg].serart
  LET oTlamrgcli.r.numcli    = FrmMrg.clival[curCli].numcli
  LET oTlamrgcli.r.qtemin    = FrmMrg.clival[curCli].qtemin
  LET oTlamrgcli.r.sermrgcli = NVL(FrmMrg.clival[curCli].sermrgcli,0)
  RETURN NOT oTlamrgcli.mrgcliexist()
END FUNCTION
FUNCTION FrmMrg_tlamrgcli_delete(d ui.Dialog,delmod STRING)
  IF delmod = 'marge' THEN
    IF fgl_winQuestion('Confirmation',SFMT('tes-vous certain de vouloir supprimer la marge du client %1 ?',FrmMrg.clival[curCli].nomcli.trim()),'Non','Non|Oui','fa-var-quest',0) = 'Oui' THEN
      IF NOT oTlamrgcli.dbdelete() THEN
        ERROR SFMT(errors['cli0006'].msg,sqlca.sqlerrm)
        RETURN
      END IF
      CALL d.deleteRow('sr_tlamrgcli',curCli)
    END IF
  END IF
  IF delmod = 'client' THEN
    IF fgl_winQuestion('Confirmation',SFMT('tes-vous certain de vouloir supprimer toutes les marges du client %1 ?',FrmMrg.clival[curCli].nomcli.trim()),'Non','Non|Oui','fa-var-quest',0) = 'Oui' THEN
      VAR p  INTEGER
      FOR p = FrmMrg.clival.getLength() TO 1 STEP -1
        IF FrmMrg.clival[p].numcli <> oTlamrgcli.r.numcli THEN CONTINUE FOR END IF
        LET oTlamrgcli.r.sermrgcli = FrmMrg.clival[p].sermrgcli
        IF NOT oTlamrgcli.dbdelete() THEN
          ERROR SFMT(errors['cli0006'].msg,sqlca.sqlerrm)
          EXIT FOR
        END IF
        CALL d.deleteRow('sr_tlamrgcli',p)
      END FOR
    END IF
  END IF
END FUNCTION
FUNCTION FrmMrg_tlamrgcli_paste()
  DEFINE i       INTEGER
  DEFINE j       INTEGER
  DEFINE l1      INTEGER
  DEFINE l2      INTEGER
  DEFINE flg     BOOLEAN

  IF fgl_winQuestion('Confirmation',SFMT('tes-vous certain de vouloir coller les marges clients de l''article : %1 ?',Copy.clilibart.trim()),'Non','Non|Oui','fa-var-quest',0) = 'Oui' THEN
    LET l1 = Copy.clival.getLength()
    IF l1 = 0 THEN RETURN END IF
    FOR i = 1 TO l1
      -- Y-a-t-il dj une marge dfinie pour le groupe et qte minimum ...
      LET flg = FALSE
      LET l2 = FrmMrg.clival.getLength()
      FOR j = 1 TO l2
        LET flg = FrmMrg.clival[j].numcli = Copy.clival[i].numcli AND
                  FrmMrg.clival[j].qtemin = Copy.clival[i].qtemin
        IF flg THEN EXIT FOR END IF
      END FOR
      IF flg THEN CONTINUE FOR END IF
      LET oTlamrgcli.r.serart = FrmMrg.mrgval[curMrg].serart
      LET oTlamrgcli.r.numcli = Copy.clival[i].numcli
      LET oTlamrgcli.r.datmrg = Copy.clival[i].datmrg
      LET oTlamrgcli.r.mrgcli = Copy.clival[i].mrgcli
      LET oTlamrgcli.r.qtemin = Copy.clival[i].qtemin
      LET oTlamrgcli.r.utldmd = Copy.clival[i].utldmd
      IF oTlamrgcli.dbupdate() THEN END IF
    END FOR
  END IF
END FUNCTION

--////////////////////////////////////////////////////////////////////////////--
-- Fonctions pour gestion du tableau des marges par groupes (tlamrggrp)       --
--\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\--
{Chargement du tableau des prix bloqus GROUPES sur base de l'article courant (curMrg)}
FUNCTION FrmMrg_tlamrggrp_populate(grpprm STRING)
  DEFINE i                        INTEGER
  DEFINE j                        INTEGER
  DEFINE k                        INTEGER
  DEFINE l1                       INTEGER
  DEFINE l2                       INTEGER
  DEFINE rq                       STRING
  DEFINE rsel_tlamrggrp RECORD
     sermrggrp                    INTEGER
    ,serart                       INTEGER
    ,datmrg                       DATE
    ,grpprm                       STRING
    ,mrggrp                       DECIMAL(6,2)
    ,qtemin                       DECIMAL(9,3)
    ,utldmd                       STRING
    ,datsys                       DATETIME YEAR TO SECOND
    ,libgrp                       STRING
     END RECORD

  LET k = cache_histo.search('serart', FrmMrg.mrgval[curMrg].serart)
  IF grpprm IS NULL THEN
    CALL FrmMrg.grpval.clear() -- On vide le tableau des marges lies aux groupes et on charge les nouvelles donnes
    CALL FrmMrg.grpatt.clear() -- On vide le tableau des attributs
    LET rq = 'SELECT a.sermrggrp'                                      -- sermrggrp                      INTEGER
          ||       ',a.serart'                                         -- serart                         INTEGER
          ||       ',a.datmrg'                                         -- datmrg                         DATE
          ||       ',a.grpprm'                                         -- grpprm                         STRING
          ||       ',a.mrggrp'                                         -- mrggrp                         DECIMAL(6,2)
          ||       ',a.qtemin'                                         -- qtemin                         DECIMAL(10,4)
          ||       ',a.utldmd'                                         -- utldmd                         STRING
          ||       ',a.datsys'                                         -- datsys                         DATETIME YEAR TO SECOND
          ||       ',b.grdes'                                          -- libgrp                         STRING
          ||  ' FROM tlamrggrp a'
          ||       ',OUTER fdcgrp b'
          || ' WHERE a.grpprm = b.promgr'
          ||   ' AND a.datmrg = (SELECT MAX(datmrg) FROM tlamrggrp d WHERE d.grpprm=a.grpprm AND d.serart=a.serart AND a.qtemin = d.qtemin)'
    LET rq = rq.trim(),' AND a.serart=' || FrmMrg.mrgval[curMrg].serart
    LET rq = rq.trim(),' ORDER BY a.grpprm,a.qtemin'
    DECLARE csel_tlamrggrp CURSOR FROM rq
    LET rq = '("."' -- Pour des raisons de performances on construit une seule requte pour chercher les statistiques des ventes
    FOREACH csel_tlamrggrp INTO rsel_tlamrggrp.*
      -- Si le groupe n'est pas dans le cache ...
      IF k = 0 OR cache_histo[k].hisgrp.search('cligrp',rsel_tlamrggrp.grpprm) = 0 THEN
        LET rq = rq.trim() || SFMT(',"%1"',rsel_tlamrggrp.grpprm CLIPPED)
      END IF
      LET FrmMrg.grpval[i:=i+1].sermrggrp = rsel_tlamrggrp.sermrggrp
      LET FrmMrg.grpval[i].datmrg         = rsel_tlamrggrp.datmrg
      LET FrmMrg.grpval[i].grpprm         = rsel_tlamrggrp.grpprm
      LET FrmMrg.grpval[i].mrggrp         = rsel_tlamrggrp.mrggrp
      LET FrmMrg.grpval[i].qtemin         = rsel_tlamrggrp.qtemin
      LET FrmMrg.grpval[i].utldmd         = rsel_tlamrggrp.utldmd
      LET FrmMrg.grpval[i].datsys         = rsel_tlamrggrp.datsys
      LET FrmMrg.grpval[i].prxprm         = FrmMrg.mrgval[curMrg].pxaref * (1+(rsel_tlamrggrp.mrggrp/100))
      LET FrmMrg.grpval[i].libgrp         = rsel_tlamrggrp.libgrp
      LET FrmMrg.grpval[i].mrgupd         = FALSE
      LET FrmMrg.grpatt[i].libgrp         = cbasRouge
      LET FrmMrg.grpatt[i].qtemin         = IIF(rsel_tlamrggrp.qtemin >=1,cwcrFramboise,'')
      -- mj prcmin possible dans tableau des marges std/qte
      LET FrmMrg.mrgval[curMrg].prcmin = IIF(FrmMrg.mrgval[curMrg].prcmin IS NULL OR rsel_tlamrggrp.mrggrp<FrmMrg.mrgval[curMrg].prcmin,rsel_tlamrggrp.mrggrp,FrmMrg.mrgval[curMrg].prcmin)
    END FOREACH
    LET FrmMrg.mrgval[curMrg].prcmin = IIF(FrmMrg.mrgval[curMrg].prcmin IS NULL,20,FrmMrg.mrgval[curMrg].prcmin)
    FREE csel_tlamrggrp
    LET rq = rq.trim() || ')'
    LET curGrp = IIF(i>0,1,0)
    IF curGrp = 0 THEN RETURN END IF
  ELSE
    LET rq = SFMT('("%1")',grpprm)
  END IF
  -- Charger le tableau des prix bloqus sur base d'un ou de plusieurs groupes
  -- le paramtre rq contient un chane de type IN avec le ou les codes groupes '("DANY","EURES",...)'
  -- il y a un tableau "cache" pour ne pas faire les requtes SQL plusieurs fois
  IF k > 0 THEN
    LET rq = IIF((grpprm IS NOT NULL AND j:=cache_histo[k].hisgrp.search('cligrp',grpprm) > 0),'',rq)
    LET rq = IIF(rq='(".")','',rq)
  END IF
  IF rq IS NOT NULL THEN
    -- Si pas de cache chercher les valeurs dans la DB ...
    LET k = IIF(k=0,cache_histo.getLength()+1,k)
    LET cache_histo[k].serart = FrmMrg.mrgval[curMrg].serart
    {Si pas de cache chercher les valeurs dans les db statis et provencale ...}
    LET rq = 'SELECT d.promgr,YEAR(execdate),CASE WHEN NVL(serprm,0)<>0 THEN "2" ELSE "0" END,MIN(execdate),MAX(execdate),SUM(delqty)'
          ||  ' FROM sstoarlp a,sstamas b,sstclink c,fdcmas d '
          || ' WHERE a.artid  = b.artid'
          ||   ' AND a.custid = c.custid'
          ||   ' AND c.nrin   = d.custnr'
          ||   ' AND b.artidp = '  || FrmMrg.mrgval[curMrg].serart
          ||   ' AND d.promgr IN ' || rq.trim()
          ||   ' AND execdate BETWEEN TODAY-365 AND TODAY'
          || ' GROUP BY 1,2,3'
          || ' UNION '  
          || 'SELECT d.promgr,YEAR(execdate),CASE WHEN NVL(serprm,0)<>0 THEN "2" ELSE "0" END,MIN(execdate),MAX(execdate),SUM(delqty)'
          ||  ' FROM sstoarl a,sstamas b,sstclink c,fdcmas d '
          || ' WHERE a.artid = b.artid'
          ||   ' AND a.custid = c.custid'
          ||   ' AND c.nrin   = d.custnr'
          ||   ' AND b.artidp = '  || FrmMrg.mrgval[curMrg].serart
          ||   ' AND d.promgr IN ' || rq.trim()
          ||   ' AND execdate BETWEEN TODAY-365 AND TODAY'
          || ' GROUP BY 1,2,3'
          || ' UNION '
          || 'SELECT d.promgr,YEAR(execdate),CASE WHEN NVL(serprm,0)<>0 THEN "2" ELSE "0" END,MIN(execdate),MAX(execdate),SUM(delqty)'
          ||  ' FROM fdoarl a,fdomas b,fdcmas d'
          || ' WHERE a.ordrf=b.ordrf'
          ||   ' AND a.linestat = 7'
          ||   ' AND a.serart = '  || FrmMrg.mrgval[curMrg].serart
          ||   ' AND a.datliv >= TODAY-180'
          ||   ' AND b.ordstat = 7'
          ||   ' AND b.execdate >= TODAY-180'
          ||   ' AND d.promgr IN ' || rq.trim()
          ||   ' AND b.custnr = d.custnr'
          || ' GROUP BY 1,2,3'
    DECLARE csel_hisgrp CURSOR FROM rq
    LET j = IIF(j=0,cache_histo[k].hisgrp.getLength(),j)
    FOREACH csel_hisgrp INTO cache_histo[k].hisgrp[j:=j+1].*
    END FOREACH
    CALL cache_histo[k].hisgrp.deleteElement(j) -- attention il faut supprimer le dernier lment a cause de la syntaxe [j:=j+1] car le j est incrment avant le FOREACH
  END IF
  -- on met a jour le tableau cran (clival) sur base des donnes du tableau cache (cache_histo)
  LET l1 = FrmMrg.grpval.getLength()
  FOR i = 1 TO l1
    LET FrmMrg.grpval[i].qteven = 0
    LET l2 = cache_histo[k].hisgrp.getLength()
    FOR j = 1 TO l2
      IF FrmMrg.grpval[i].grpprm = cache_histo[k].hisgrp[j].cligrp THEN
        LET FrmMrg.grpval[i].datprmven = IIF(FrmMrg.grpval[i].datprmven IS NULL,cache_histo[k].hisgrp[j].datprmven,FrmMrg.grpval[i].datprmven)
        LET FrmMrg.grpval[i].datdrnven = cache_histo[k].hisgrp[j].datdrnven
        LET FrmMrg.grpval[i].qteven    = FrmMrg.grpval[i].qteven + cache_histo[k].hisgrp[j].qteliv
        LET FrmMrg.grpatt[i].libgrp    = IIF(FrmMrg.grpval[i].datdrnven+6 UNITS MONTH>TODAY,'',FrmMrg.grpatt[i].libgrp)
      END IF
    END FOR
  END FOR
END FUNCTION
FUNCTION FrmMrg_tlamrggrp_input(d ui.Dialog) RETURNS BOOLEAN
  DEFINE flgadd               BOOLEAN
  DEFINE flglstfld            BOOLEAN

  IF oTlamrg.sermrg = 0 THEN RETURN flgadd END IF -- si pas marge std/qte on autorise pas l'accs aux marges clients
  CALL FrmMrg_setModeEdition()
  INPUT FrmMrg.grpval[curGrp].* WITHOUT DEFAULTS FROM sr_tlamrggrp[linGrp].* ATTRIBUTES(UNBUFFERED)
    BEFORE INPUT
      CALL d.setFieldActive('sr_tlamrgmrg.*',FALSE) -- on interdit accs au tabelau des marges std/qte
      CALL d.setFieldActive('sr_tlamrgcli.*',FALSE) -- on interdit accs au tableau des marges clients
      LET flgadd    = (oTlamrggrp.r.sermrggrp == 0)
      LET flglstfld = NOT flgadd                    -- en mode "insert" le flglstfld est positionn a FALSE pour obliger la saisie de tous les champs                                                                                    
      LET FrmMrg.grpval[curGrp].datmrg = IIF(flgadd,TODAY,FrmMrg.grpval[curGrp].datmrg)
    AFTER INPUT
      CALL d.setFieldActive('sr_tlamrgmrg.*',TRUE)  -- on rtabli accs au marge std/qte
      CALL d.setFieldActive('sr_tlamrgcli.*',TRUE)  -- on rtabli accs au tableau des marges clients
    BEFORE FIELD grpprm02,qtemin02
      IF NOT flgadd THEN NEXT FIELD NEXT END IF -- champs client et qte mini inaccessibles en "modification"
    BEFORE FIELD utldmd02                       -- lorsqu'on rentre dans le dernier champ on le signal (flglstfld)
      LET FrmMrg.grpval[curGrp].utldmd = IIF(FrmMrg.grpval[curGrp].utldmd IS NULL,oTlamrggrp.r.utldmd,FrmMrg.grpval[curGrp].utldmd)
      LET flglstfld = TRUE                                                                                                                                                                                                               
    AFTER FIELD grpprm02,mrggrp02,qtemin02,utldmd02
      IF NOT FrmMrg_tlamrggrp_validate(FIELD_TOUCHED(sr_tlamrggrp.*),afterRow:FALSE) THEN
        CALL DIALOG.nextField(name:errors[errkey].nxt)
      END IF
    ON ACTION ACCEPT
      IF NOT flglstfld THEN
        ERROR errors['grp0005'].msg
      ELSE
        IF FrmMrg_tlamrggrp_validate(FIELD_TOUCHED(sr_tlamrggrp.*),afterRow:TRUE) THEN EXIT INPUT END IF
      END IF
    ON ACTION CANCEL -- Si on abandonne en mode cration on supprime l'lment du tableau
      LET flgadd = NOT FrmMrg_tlamrggrp_resetInput()
      EXIT INPUT
  END INPUT
  CALL FrmMrg_razModeEdition()
  RETURN flgadd
END FUNCTION                                                                                                                                                                                                                             
FUNCTION FrmMrg_tlamrggrp_resetInput() RETURNS BOOLEAN
  IF oTlamrggrp.r.sermrggrp = 0 THEN
    CALL FrmMrg.grpval.deleteElement(curGrp)
    CALL FrmMrg.grpatt.deleteElement(curGrp)
  ELSE
    LET FrmMrg.grpval[curGrp] = FrmMrg.grpvalsav
    LET FrmMrg.grpatt[curGrp] = FrmMrg.grpattsav
  END IF
  RETURN TRUE
END FUNCTION
FUNCTION FrmMrg_tlamrggrp_setcurrent(c INTEGER, l INTEGER)
  LET curGrp = IIF(c IS NOT NULL,c,curGrp)
  LET linGrp = IIF(l IS NOT NULL,l,linGrp)
  LET FrmMrg.lsermrggrp    = FrmMrg.grpval[curGrp].sermrggrp
  LET oTlamrggrp.r.sermrggrp = NVL(FrmMrg.grpval[curGrp].sermrggrp,0)
  LET FrmMrg.grpval[curGrp].datmrg = IIF(oTlamrggrp.r.sermrggrp=0,TODAY,FrmMrg.grpval[curGrp].datmrg)
  LET FrmMrg.lsermrgcli    = NULL
  LET oTlamrggrp.r.grpprm  = FrmMrg.grpval[curGrp].grpprm
  LET oTlamrggrp.r.utldmd  = FrmMrg.grpval[curGrp].utldmd
  LET FrmMrg.grpvalsav     = FrmMrg.grpval[curGrp] -- on sauvegarde une copie du record en cours (valeurs)
  LET FrmMrg.grpattsav     = FrmMrg.grpatt[curGrp] -- on sauvegarde une copie du record en cours (attributs)
  DISPLAY FrmMrg.lsermrgcli TO lsermrgcli
  DISPLAY FrmMrg.lsermrggrp TO lsermrggrp
END FUNCTION
FUNCTION FrmMrg_tlamrggrp_validate(fieldTouched BOOLEAN,afterRow BOOLEAN) RETURNS BOOLEAN
  DEFINE fldnam     STRING

  LET errkey = ''
  IF (modeTableau) AND (NOT fieldTouched) THEN RETURN IIF(afterRow,FrmMrg_tlamrggrp_resetInput(),TRUE) END IF  -- En mode tableau (INPUT ARRAY) si le champ n'a pas t "touch" on ne fait rien
  LET fldnam = fgl_dialog_getfieldname()
  IF afterRow THEN
    CASE fldnam -- On force la rcupration de la valeur du champ dans le cas de afterRow car l'after field n'a pas t dclench
      WHEN 'grpprm02' LET FrmMrg.grpval[curGrp].grpprm = fgl_dialog_getbuffer()
      WHEN 'mrggrp02' LET FrmMrg.grpval[curGrp].mrggrp = fgl_dialog_getbuffer()
      WHEN 'qtemin02' LET FrmMrg.grpval[curGrp].qtemin = fgl_dialog_getbuffer()
      WHEN 'utldmd02' LET FrmMrg.grpval[curGrp].utldmd = fgl_dialog_getbuffer()
    END CASE
    LET fldnam = 'all'
  END IF
  CASE
    WHEN fldnam IN ('all','grpprm02') AND
         NOT FrmMrg_tlamrggrp_setgroupe(refreshVentes:(fldnam<>'all'))  LET errkey = 'grp0001'
    WHEN fldnam IN ('all','mrggrp02') AND
         (FrmMrg.grpval[curGrp].mrggrp IS NULL OR
          FrmMrg.grpval[curGrp].mrggrp >= FrmMrg.mrgval[curMrg].mrgqte) LET errkey = 'grp0002'
    WHEN fldnam IN ('all','qtemin02') AND
         FrmMrg.grpval[curGrp].qtemin IS NULL                           LET errkey = 'grp0003'
    WHEN fldnam IN ('all','qtemin02') AND
         NOT FrmMrg_tlamrggrp_setqtemin()                               LET errkey = 'grp0004'
    WHEN fldnam IN ('all','utldmd02') AND
         NVL(FrmMrg.grpval[curGrp].utldmd,' ') = ' '                    LET errkey = 'grp0007'
    WHEN afterRow
      LET oTlamrggrp.r.serart = FrmMrg.mrgval[curMrg].serart
      LET oTlamrggrp.r.datmrg = FrmMrg.grpval[curGrp].datmrg
      LET oTlamrggrp.r.mrggrp = FrmMrg.grpval[curGrp].mrggrp
      LET oTlamrggrp.r.qtemin = FrmMrg.grpval[curGrp].qtemin
      LET oTlamrggrp.r.utldmd = FrmMrg.grpval[curGrp].utldmd
      LET FrmMrg.grpval[curGrp].prxprm = FrmMrg.mrgval[curMrg].pxaref * (1+(oTlamrggrp.r.mrggrp/100))
      IF oTlamrggrp.dbupdate() THEN
        LET FrmMrg.grpval[curGrp].sermrggrp = oTlamrggrp.r.sermrggrp
        LET FrmMrg.grpatt[curGrp].datmrg    = cvvrLime
        LET FrmMrg.grpatt[curGrp].mrggrp    = cvvrLime
        LET FrmMrg.grpatt[curGrp].qtemin    = cvvrLime
        LET FrmMrg.grpatt[curGrp].utldmd    = cvvrLime
        RETURN TRUE
      END IF
      LET errkey = 'cli0006'
  END CASE
  CASE errors[errkey].ctx
    WHEN 0 ERROR errors[errkey].msg
    WHEN 1 ERROR SFMT(errors[errkey].msg,sqlca.sqlerrm)
  END CASE
  RETURN (errkey IS NULL)
END FUNCTION
FUNCTION FrmMrg_tlamrggrp_setgroupe(refreshVentes BOOLEAN) RETURNS BOOLEAN
  LET oTlamrggrp.r.grpprm = FrmMrg.grpval[curGrp].grpprm
  CALL oTlamrggrp.groupe()
  LET FrmMrg.grpval[curGrp].libgrp = oTlamrggrp.c.libgrp
  LET FrmMrg.grpval[curGrp].grpprm = oTlamrggrp.r.grpprm
  IF oTlamrggrp.c.libgrp IS NOT NULL AND refreshVentes THEN
    CALL FrmMrg_tlamrggrp_populate(grpprm:oTlamrggrp.r.grpprm)
  END IF
  RETURN (oTlamrggrp.c.libgrp IS NOT NULL)
END FUNCTION
FUNCTION FrmMrg_tlamrggrp_setqtemin() RETURNS BOOLEAN
  LET oTlamrggrp.r.serart    = FrmMrg.mrgval[curMrg].serart
  LET oTlamrggrp.r.grpprm    = FrmMrg.grpval[curGrp].grpprm
  LET oTlamrggrp.r.qtemin    = FrmMrg.grpval[curGrp].qtemin
  LET oTlamrggrp.r.sermrggrp = NVL(FrmMrg.grpval[curGrp].sermrggrp,0)
  RETURN NOT oTlamrggrp.mrggrpexist()
END FUNCTION
FUNCTION FrmMrg_tlamrggrp_delete(d ui.Dialog,delmod STRING)
  IF delmod = 'marge' THEN
    IF fgl_winQuestion('Confirmation',SFMT('tes-vous certain de vouloir supprimer la marge du groupe %1 ?',FrmMrg.grpval[curGrp].libgrp.trim()),'Non','Non|Oui','fa-var-quest',0) = 'Oui' THEN
      IF NOT oTlamrggrp.dbdelete() THEN
        ERROR SFMT(errors['grp0006'].msg,sqlca.sqlerrm)
        RETURN
      END IF
      CALL d.deleteRow('sr_tlamrggrp',curGrp)
    END IF
  END IF
  IF delmod = 'groupe' THEN
    IF fgl_winQuestion('Confirmation',SFMT('tes-vous certain de vouloir supprimer toutes les marges du groupe %1 ?',FrmMrg.grpval[curGrp].libgrp.trim()),'Non','Non|Oui','fa-var-quest',0) = 'Oui' THEN
      VAR p  INTEGER
      FOR p = FrmMrg.grpval.getLength() TO 1 STEP -1
        IF FrmMrg.grpval[p].grpprm <> oTlamrggrp.r.grpprm THEN CONTINUE FOR END IF
        LET oTlamrggrp.r.sermrggrp = FrmMrg.grpval[p].sermrggrp
        IF NOT oTlamrggrp.dbdelete() THEN
          ERROR SFMT(errors['grp0006'].msg,sqlca.sqlerrm)
          EXIT FOR
        END IF
        CALL d.deleteRow('sr_tlamrggrp',p)
      END FOR
    END IF
  END IF
END FUNCTION
FUNCTION FrmMrg_tlamrggrp_paste()
  DEFINE i       INTEGER
  DEFINE j       INTEGER
  DEFINE l1      INTEGER
  DEFINE l2      INTEGER
  DEFINE flg     BOOLEAN

  IF fgl_winQuestion('Confirmation',SFMT('tes-vous certain de vouloir coller les marges groupes de l''article : %1 ?',Copy.clilibart.trim()),'Non','Non|Oui','fa-var-quest',0) = 'Oui' THEN
    LET l1 = Copy.grpval.getLength()
    IF l1 = 0 THEN RETURN END IF
    FOR i = 1 TO l1
      -- Y-a-t-il dj une marge dfinie pour le groupe et qte minimum ...
      LET flg = FALSE
      LET l2 = FrmMrg.grpval.getLength()
      FOR j = 1 TO l2
        LET flg = FrmMrg.grpval[j].grpprm = Copy.grpval[i].grpprm AND
                  FrmMrg.grpval[j].qtemin = Copy.grpval[i].qtemin
        IF flg THEN EXIT FOR END IF
      END FOR
      IF flg THEN CONTINUE FOR END IF
      LET l2 += 1
      LET oTlamrggrp.r.serart = FrmMrg.mrgval[curMrg].serart
      LET oTlamrggrp.r.grpprm = Copy.grpval[i].grpprm
      LET oTlamrggrp.r.datmrg = Copy.grpval[i].datmrg
      LET oTlamrggrp.r.mrggrp = Copy.grpval[i].mrggrp
      LET oTlamrggrp.r.qtemin = Copy.grpval[i].qtemin
      LET oTlamrggrp.r.utldmd = Copy.grpval[i].utldmd
      IF oTlamrggrp.dbupdate() THEN END IF
    END FOR
  END IF
END FUNCTION
